



// MetaQuote [ MQ 4 ] 
#define                               IDENTIFICATION~DIVISION                                    10
// v1 




                #define   @_ProgramName         "Crayon Trend Lines"
                #define   @_SystemSymbol        "CTL"
                #define   @_FileName            "Crayon Trend Lines v100 b02.mq4"
                #define   @_SystemName          "N/A"
                #define   @_Author              "Keit Thomas Largo"
                #define   @_eMail               "CockeyedCowboy@gmail.com"
                #define   @_CompanyName         "WinSoft Technology  "
                #define   @_LicenseTo           "Open Source"
                #define   @_ModuleType          "Custom Indicator"
                #define   @_DateWriten          "03.06.2012"
                #define   @_VersionNumber       "1.00 b02 pb"
                #define   @_LastUpDate          "03.19.2012"
                #define   @_ProgramLanguage     "MetaQuote  MQL v4.00, b409"
                #define   @_Documentation       "see {Documentation Division}"
                #define   @_CopyRight           "CopyRight   2012"




//
string @_CopyRightWarning[]={// 20x70 




                "  The \'Crayon Trend Lines\' indicator, its supportive file, and   ",
                "  any created data files if any, are CopyRighted material of Keit  ",
                "  Thomas Largo and WinSoft Technology.  You must treat this soft-  ",
                "  ware like any other copyrighted material. The Author has freely  ",
                "  released this  version of the  software to the members of the \' ",
                "  Forex Factory\' Forum.  As an aid in their private and presonal  ",
                "  trading operation. You are NOT permitted to rent, sell, resell,  ",
                "  or otherwise distribute this software in any commercial and /or  ",
                "  profitable endeavors, with out the written  permission from the  ",
                "            author. No other rights are granded.                   ",

			    "                ~~~ Keit Thomas Largo ~~~                          ",




@_End};//
string @_VersionComments[]={// 10x70 




                 "      WARNING: THIS IS AN BETA RELEASE,  EXPECT SOME BUGS       ",

                 "   WinSoft Technology Inc.,  EXPRESSLY DISCLAIMS ANY WARRANTY   ",
                 "   for this  SOFTWARE.  The  SOFTWARE  along with any related   ",
                 "   documentation is provided   AS IS   without any waranties,   ",
                 "   either express or implied. Including, the implied warranty   ",
                 "   of merchantability or fitness for any  particular purpose.   ",
                 "   The entire risks  arising out of  usage or performance  of   ",
                 "   this SOFTWARE, re-mains with the user.  WinSoft Technology   ",
                 "   Inc. assumes  NO LIABILITY FOR DAMAGES OR LOSS  whatsoever   ",
                 "   arising from the use or inability of use of this SOFTWARE.   ",




@_End};//
#define                                COMPILER~DIRECTIVES                                       20
//  FILE LINKAGE: 




                    #import "Mouse.dll"
                        int MT4_ScreenToClient( int Control, int& MouseOver[] );

                    #import




//
#define                                ENVIRONMENT~DIVISION                                      30
//  DEFINED CONSTANT: 




                #define        @_Count                            0  // 
                #define        @_Total                            1  // 
                #define        @_ON                               1  // 
                #define        @_OFF                              0  // 
                #define        @_Hold                             1  // 
                #define        @_Break                            2  // 

                #define        @_Holding                          0  // 
                #define        @_Broken                           4  // 
                #define        @_Show                             0  // 
                #define        @_Hide                            -1  // 
                #define        @_LowSR                            2  // 
                #define        @_HighSR                           1  // 
                #define        @_Failed                          -1  // 
                #define        @_Empty                            0  // 
                #define        @_Clear                           ""  // 
                #define        $_MainWindow                       0  // 
                #define        @_UnKnown                         -1  // 
                #define        @_CloseBar                         1  // 
                #define        @_OpenBar                          0  // 

                #define        @_Text                 DarkSlateGray  // Color of screen text
                #define        @_Single                    CLR_NONE  // No color
                #define        @_WaterMark            C'036,046,020' // Prompt Zone color
                #define        @_BoxColor             C'000,074,074' // Box boarder color
                #define        @_MinorColor                     Red  // Active color
                #define        @_SecondaryColor                Lime  // Active color
                #define        @_PrimaryColor                  Blue  // Active color
                #define        @_ExtendedColor                 Gold  // Active color
                #define        @_BrokeMinorColor      C'120,044,044' // Dark red color
                #define        @_BrokeSecondaryColor  C'024,112,024' // Dark green color
                #define        @_BrokePrimaryColor    C'034,068,102' // Dark blue color
                #define        @_BrokeExtendedColor   C'090,068,001' // Dark gold color





//
//  EXTERN PARAMETER: 




//
//  DEFAULT ATTRIBUTES: 




        bool
            ShowBox        =   True, // Box Drawing Switch, turns on and off the price box.
            ShowSRmarks    =   True, // This turns on and off the RS arrows.
            UnderPrice     =  False, // Switch to place lines on top of or below price bars.
            SoundAlert     =   True, // Switch to turn on and off PlaySound() function.
            @_Refresh      =   True; // Switch to Refresh Graphic Display.


        int
            DefaultStart   =   85, // Default start position Bar count of trend line output.
            DefaultStop    =   60, // Default stop position Bar count of trend line output.
            ExpandBox      =    7, // Pips from high price/to box top and low price/to box bottom.
            PipsWarning    =    2, // The number of pips to start warning of a line break.
            PipsBreaking   =    2; // The number of pips to determine a line break.


        double
            DefaultPrice   =   25; // Price level in pips new lines are drawn from top of box.




//
//  GLOBAL SCOPE VARIABLES: 




        int
            BarsInView          =   @_Empty, // Bar count of the first bar on left edge.
            BarsOnChart         =   @_Empty, // Bar count of total number of bars on chart.
            BarsToChart         =   @_Empty, // Contains how many bars the chart in view contains.
            $_ChartScale        =   @_Empty, // Is the current time scale of main window;
            BarAdj              =   @_Empty; // Number of missing bars over week end.


        double
            LastHighPrice       =   @_Empty, // Holds the last highprice the chart has reached.
            LastLowPrice        =   @_Empty; // Holds the last lowprice the chart has reached.


        string
            PageLayer           =   @_Clear, // Holds the Graphic page and layering index.
            SystemObjects       =   @_Clear, // Systems objects base name.
            $_ProgramObject     =   @_Clear, // The base Object Name registered to a program;
            $_Pair              =   @_Clear, // The currentcy pair that is shown on main chart window;
            $_ProgramID         =   @_Clear, // Program's code, Unique string Identerfier 3 digit number;
            $_ControlID         =   @_Clear, // Controller's, Unique String Identerfier;
            UPTrendBreak        =   @_Clear, // SoundWave informs user of an up trend break.
            DNTrendBreak        =   @_Clear, // SoundWave informs user of a down trend break.
            SRResistance        =   @_Clear, // SoundWave informs user of a ressitance line break.
            SRSupport           =   @_Clear, // SoundWave informs user of a support line break.
            RangeBOup           =   @_Clear, // SoundWave informs user of a up side range break out.
            RangeBOdown         =   @_Clear, // SoundWave informs user of a down side range break out.
            RequiresDLLs        =   @_Clear, // SoundWave to informs user to turn on dll files.
            WelcomeLine         =   @_Clear, // SoundWave to welcome user to this program.
            FinishTrading       =   @_Clear; // SoundWave to amuse the user on exit.




//
//  GLOBAL SCOPE ARRAYS: 




        int
            TrendLines  [ 2 ][ 5 ]; // Holds the count of trendlines on chart.


        string
            LastSound   [ 7 ][ 5 ]; // Holds the last lines that triggered a sound wave.


        color
            TrendColors [ 3 ][ 5 ]; // This array holds the color of all trend lines on graphs.




//
#define                                   CODING~DIVISION                                        50
//




void
    InitializeCrayonTrendLines() {

            $_ControlID      =  @_UnKnown;
            $_Pair           =  Symbol();
            $_ChartScale     =  Period();
            $_ProgramID      =  DoubleToStr( $_GetNumberID(), 0 ) + " ";
            $_ProgramObject  =  $_ProgramID + @_SystemSymbol + " ";
            PageLayer        =  "5.51 " + $_ProgramObject + DoubleToStr( $_MainWindow, 0 );
            SystemObjects    =  PageLayer + " Line Creator ";

            PipsWarning      =  MathMin( 10, MathMax(  1, PipsWarning  ));
            PipsBreaking     =  MathMin( 10, MathMax(  1, PipsBreaking ));
            ExpandBox        =  MathMin( 10, MathMax(  1, ExpandBox    ));
            DefaultPrice     =  MathMin( 30, MathMax( 10, DefaultPrice ));

            UPTrendBreak     =  "Up Trend Broken.wav";
            DNTrendBreak     =  "Down Trend Broken.wav";
            SRResistance     =  "Resistance Broken.wav";
            SRSupport        =  "Support Broken.wav";
            RangeBOup        =  "Range BO up side.wav";
            RangeBOdown      =  "Range BO down side.wav";
            RequiresDLLs     =  "DLL Libraries Required.wav";
            WelcomeLine      =  "Welcome to trend lines.wav";

                BarAdj  =  TheBlackHole( TimeCurrent(), $_ChartScale );

                if( Digits == 5 || Digits == 3 ) {
                    PipsWarning   =  PipsWarning  * 10;
                    PipsBreaking  =  PipsBreaking * 10;
                    ExpandBox     =  ExpandBox    * 10;
                    DefaultPrice  =  DefaultPrice * 10;

                } // End If, Digits:

                TrendColors[ 1 ][ 0 ]  =  @_Empty;
                TrendColors[ 1 ][ 1 ]  =  @_MinorColor;
                TrendColors[ 1 ][ 2 ]  =  @_SecondaryColor;
                TrendColors[ 1 ][ 3 ]  =  @_PrimaryColor;
                TrendColors[ 1 ][ 4 ]  =  @_ExtendedColor;

                TrendColors[ 2 ][ 0 ]  =  @_Empty;
                TrendColors[ 2 ][ 1 ]  =  @_BrokeMinorColor;
                TrendColors[ 2 ][ 2 ]  =  @_BrokeSecondaryColor;
                TrendColors[ 2 ][ 3 ]  =  @_BrokePrimaryColor;
                TrendColors[ 2 ][ 4 ]  =  @_BrokeExtendedColor;

    return;

} // End Routine Procedure, InitializeCrayonTrendLines:




void
    RunCrayonTrendLines() {

                BarsInView   =  WindowFirstVisibleBar();
                BarsOnChart  =  WindowBarsPerChart   ();
                BarsToChart  =  MathMin( BarsInView, BarsOnChart );
                $_ControlID  =  WindowHandle( $_Pair, $_ChartScale );

                    if( IsDllsAllowed() ) {
                        if( IsConnected() ){
                            PlayWave( True, "Welcome", WelcomeLine, 0 );
                            $_DeleteGraphicPage( 5.53 );
                            if( @_Refresh )   {   DeleteUnUsedArrows();   }

                            OutPut();

                        } else {
                            DeActivateCrayons( $_ProgramObject );

                        } // End If, IsConnected:

                    } else {   PlayWave( True, "Dll Library", RequiresDLLs, 0 );   }

    return;

} // End Routine Procedure, RunCrayonTrendLines:




void
    OutPut() {

            TrendLineCreator( SystemObjects, TrendLines, TrendColors, BarsInView );
            UpDateTrendLines( SystemObjects, TrendLines, TrendColors, BarsInView );

    return;

} // End Routine Procedure, OutPut:




void
    DeInitializeCrayonTrendLines() {

                    $_ClearAllGraphics( $_ProgramObject );

    return;

} // End routine Procedure, DeInitializeCrayonTrendLines:




//
#define                            FUNCTION~DEFINITION~DIVISION                                  80
//  OBJECT PROPERTIES: 




//
//  FUNCTION PROCEDURES: 
//
//  FUNCTION PROCEDURES: 




/*===============================================================================================|\
||                                                                                               ||
||  TheBlackHole Function Procedure                 v1.00              Date 03.08.2012     KTL   ||
||                                                                                               ||
||  Returns:     The missing bar count based on the chart scale, for which your broker is        ||
||               closed for the week end. If weekly or monthly charts are imputed the return     ||
||               value will be zero as there are no missing bars in either of those time scales. ||
||                                                                                               ||
||  Purpose:     Is to make adjustments in bar count for indicators based on time or bar         ||
||               counts were the missing bars that occures over the week end effect results.     ||
||                                                                                               ||
||  Parameters:  ServerTime --- This in most cases will be TimeCurrent() but the option exist    ||
||                              to send other times as in GMT etc..                              ||
||               TimeScale  --- The time scale of the chart time, in most caes here the          ||
||                              Current chart scale will be inputted.                            ||
||                                                                                               ||
||  Note:        Noon times was used because all brokers will be open at noon time on fridays    ||
||               and at noon on monday, we do not have to look for each different brokers        ||
||               times of opperations. Then also to consider holidays that occure on mondays     ||
||               and or fridays which happens offen. We move the testing days to thursday and    ||
||               tuesdays at noon. 12 noon, will also, match up with all chart time scales which ||
||               include the 4Hr chart. This function returns zero if you send it weekly or      ||
||               monthly time scales as there will not be any missing bars within those time     ||
||               periods. We are still left with the problem of missing bars that may occure     ||
||               if your broker closes for a holiday during the week which may occure a few      ||
||               times a year.                                                                   ||
||                                                                                               ||
||  Example:     int AdjustBars  =  TheBlackHole( TimeCurrent(), Period() );                     ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
int
    TheBlackHole( datetime ServerTime, int TimeScale ) {
        int        Index            =   @_Empty;
        int        MissingBars      =   @_UnKnown;
        int        MinutesInDay     =   PERIOD_D1;
        int        MinutesInBar     =   TimeScale;
        int        NormalBarCount   =   MathAbs(( MinutesInDay / MinutesInBar ) * 5 );
        int        ActualBarCount   =   @_Empty;
        int        SearchDay        =   2;
        int        TuesdayBar       =   @_Empty;
        int        ThursdayBar      =   @_Empty;
        datetime   TuesdayNoon      =   @_Empty;
        datetime   ThursdayNoon     =   @_Empty;

            if( TimeScale >= PERIOD_W1 ) return( 0 );

            for( Index = 1; Index <= 2; Index ++ ) {
                while( TimeDayOfWeek( ServerTime ) != SearchDay ) {
                    while( TimeHour( ServerTime  ) != 12 ) {
                        while( TimeMinute( ServerTime ) != 0 ) {
                            ServerTime  +=  60;

                        } // End While Loop, TimeMinute:

                        if( TimeHour( ServerTime ) < 12 )
                            ServerTime  +=  3600;

                        else
                            ServerTime  -=  3600;

                    } // End While Loop, TimeHour:

                    ServerTime  -=  86400;

                } // End While Loop, TimeDayOfWeek:

                if( SearchDay == 2 ) {
                    SearchDay    =  4;
                    TuesdayNoon  =  ServerTime;

                } else {
                    ThursdayNoon =  ServerTime;

                } // End If, SearchDay:
            } // End For Loop, Index:

            TuesdayBar      =  iBarShift( $_Pair, TimeScale, TuesdayNoon  );
            ThursdayBar     =  iBarShift( $_Pair, TimeScale, ThursdayNoon );
            ActualBarCount  =  ThursdayBar - TuesdayBar;
            MissingBars     =  NormalBarCount - ActualBarCount;

    return( MissingBars );

} // End Function Procedure, TheBlackHole:




/*===============================================================================================|\
||                                                                                               ||
||  $_IFFn Function Procedure            v1.01             Date 06.20.2010               KTL     ||
||                                                                                               ||
||  Returns:     Returns the TrueCondition if the Expression is True, else it will return the    ||
||               FalseCondition.                                                                 ||
||                                                                                               ||
||  Purpose:     this is an evaluation statement that test the expression for true of false and  ||
||               returns the approperate conditional statement.                                  ||
||                                                                                               ||
||  Note:        False is the default return even if an error is encountered.                    ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
double
    $_IFFn( bool Expression, double TrueCondition, double FalseCondition ) {
        double ReturnValue   =   FalseCondition;

            if( Expression == True )   {   ReturnValue  =  TrueCondition;   }

    return( ReturnValue );

} // End Function Procedure, $_IFFn:




/*===============================================================================================|\
||                                                                                               ||
||        $_GetNumberID Function Procedure        v2.71        Date 01.22.2011       KTL         ||
||                                                                                               ||
||  Returns:     An 'int type' three digit number from 101 to 999.                               ||
||                                                                                               ||
||  Purpose:     To give each chart/indicator its own, unique object identification number. To   ||
||               prevent any program code from interferring with any other objects, globals,     ||
||               orders etc., that may co-exist along side its.                                  ||
||                                                                                               ||
||  Note:        The check of the pull number being under 100 was added because if one was too   ||
||               change the Gobal Variable by opening up the dialog box to a number under or     ||
||               over 3 digits the code did not catch it, and it was posible to run with a code  ||
||               under 3 digits. Which would not be usful as all the other code block are        ||
||               assuming and looking for an ID between 101 to 999.                              ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
int
    $_GetNumberID() {
        int      PullNumber   =   101;
        string   GlobalName   =   "PullNumber.....( Do NOT Delete )";

            if( GlobalVariableCheck( GlobalName ))
                PullNumber  =  GlobalVariableGet( GlobalName );
                if( PullNumber <= 101 )   {   PullNumber  =  101;   }

            GlobalVariableSet( GlobalName, PullNumber + 1 );

            if( GlobalVariableGet( GlobalName ) > 999 )
                GlobalVariableSet( GlobalName, 101 );

    return( PullNumber );

} // End Function Procedure, $_GetNumberID:




/*===============================================================================================|\
||                                                                                               ||
||  $_IFFs Function Procedure               v1.01             Date 07.22.2010              KTL   ||
||                                                                                               ||
||  Returns:     Returns the string based on the condition of the expression.                    ||
||                                                                                               ||
||  Purpose:     To get a string respones to a true false condition.                             ||
||                                                                                               ||
||  Note:        Example;                                                                        ||
||                  ConnectionStatus  =  $_IFFs( IsConnected(), "ON LINE", "OFF LINE" );         ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
string
    $_IFFs( bool Expression, string TrueCondition, string FalseCondition ) {
        string ReturnValue   =   " ERROR ";

            if( Expression )   {   ReturnValue  =  TrueCondition;   }
            else               {   ReturnValue  =  FalseCondition;  }

    return( ReturnValue );

} // End Function Procedure, $_IFFs:




/*===============================================================================================|\
||                                                                                               ||
||  $_OverWrite Function Procedure                 v1.00               Date 02.27.2009     KTL   ||
||                                                                                               ||
||  Returns:     Returns the altered string consisting of the original string with the incerted  ||
||               string placed in at indicated with the parameter location.                      ||
||                                                                                               ||
||  Purpose:     This will over write the main string with the contance of string incert at the  ||
||               specified location.                                                             ||
||                                                                                               ||
||  Parameters:  MainString --- This is the original string passed to the function.              ||
||               Location   --- This is the location were the incertion will start.              ||
||               InCert     --- This is the string that will be incerted.                        ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
string
    $_OverWrite( string MainString, int Location, string InCert ){
        int      Index          =   @_Empty;
        int      MainLength     =   StringLen( MainString );
        int      IncertLength   =   StringLen( InCert );
        string   ReturnString   =   @_Clear;

            for( Index = 0; Index < MainLength; Index ++ ) {
                if( Index < Location )
                    ReturnString  =  ReturnString + StringSubstr( MainString, Index, 1 );

                else if( Index < Location + IncertLength )
                    ReturnString = ReturnString + StringSubstr( InCert, Index - Location, 1 );

                else
                    ReturnString = ReturnString + StringSubstr( MainString, Index, 1 );

            } // End For Loop, Index:

    return( ReturnString );

} // End Function Procedure, $_OverWrite:




//
//  ROUTINE PROCEDURES: 




/*===============================================================================================|\
||                                                                                               ||
||  $_SwapState Routine Procedure                v1.00                Date 09.10.2009      KTL   ||
||                                                                                               ||
||  Returns:     Returns the swaped value back to the calling program through the parameter      ||
||               subject which was passed byref.                                                 ||
||                                                                                               ||
||  Purpose:     To swape to values to change the state of the subject. This can be used to make ||
||               objects blink or to get alternating colored objects in graphics.                ||
||                                                                                               ||
||  Parameters:  Subject        --- Is the variable to hold the return argument.                 ||
||               FirstArgument  --- The first argument to be alternated.                         ||
||               SecondArgument --- The second argumant to be alternated.                        ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    $_SwapState( int& Subject, int FirstArgument, int SecondArgument ) {
        int   Holder   =   Subject;

            Subject  =  FirstArgument;

            if( Holder == FirstArgument )   {   Subject  =  SecondArgument;   }

    return;

} // End Routine Procedure, $_SwapState:




/*===============================================================================================|\
||                                                                                               ||
||  TrendLineCreator Routine Procedure              v1.00             Date 02.02.2012      KTL   ||
||                                                                                               ||
||  Returns:     Nothing, however it updates the global scope line count array.                  ||
||                                                                                               ||
||  Purpose:     This routine will supply trend lines to the user to apply on the charts. When   ||
||               the user mouses over one of the colored crayons at the top of the chart a       ||
||               new trend line will appear under the crayons in the color of the crayon the     ||
||               user has selected.                                                              ||
||                                                                                               ||
||  Parameters:  Object    --- This is the global scope programs PropertyObject name.            ||
||               Window    --- This is the window were the trendlines will be created.           ||
||               LineCount --- This is the global array that keeps track of the number of        ||
||                             lines that were created in each dimentions, (color).              ||
||               Colors    --- This is the global scope array that holds the standard colors     ||
||                             of each dimentions of price cycles.                               ||
||                                                                                               ||
||  Note:        The for loop will check if there is already a trend line created that the       ||
||               user has not used yet. If it finds a new trendline it will not create another   ||
||               until that one is used. It makes no different what color it is or what color    ||
||               user is now selecting. No more lines will be generated till the current one is  ||
||               used or deleted.                                                                ||
||                                                                                               ||
||               The line count array can be used to track the different trend lines however     ||
||               it is not currently used for any purpose in this code, it may be used in a      ||
||               future version of this program.                                                 ||
||                                                                                               ||
||               the DEFAULT START AND STOP is the default location were the trendline is        ||
||               Originally drawn on the chart when you mouse over a crayon the bar location     ||
||               is set in the default attribute section in the global area of this code.        ||
||                                                                                               ||
||               The TimeVariant was added to this procedure to prevent the porgram from hand-   ||
||               int out a new trend line in the event that a new bar has been open between the  ||
||               time that the older trend line was generated and the time that it is used.      ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    TrendLineCreator( string Object, int& LineCount[][], color Colors[][], int Bar ) {
        int        MouseOver      =   @_Empty;
        int        Loop           =   @_Empty;
        int        StartTime      =   @_Empty;
        int        StopTime       =   @_Empty;
        int        TimeVariant    =   $_ChartScale * 60;
        double     Price          =   @_Empty;
        string     DrawObject     =   @_Clear;
        string     TrendObject    =   Object + "Trend ";
        datetime   StartDefault   =   Time[ Bar - DefaultStart ];
        datetime   StopDefault    =   Time[ Bar - DefaultStop  ];
        color      DrawColor      =   @_Empty;

            DrawCrayon( Object, $_MainWindow, Colors );
            BoxLimits ( Object, Bar, Price );
            PollMouse ( MouseOver );

            if( MouseOver ) {
                for( Loop = 1; Loop <= 4; Loop ++ ) {
                    DrawObject  =  TrendObject + DoubleToStr( Loop, 0 ) + " ";
                    DrawObject  =  DrawObject  + DoubleToStr( LineCount[ @_Total ][ Loop ], 0 );
                    StartTime   =  ObjectGet( DrawObject, OBJPROP_TIME2 );
                    StopTime    =  ObjectGet( DrawObject, OBJPROP_TIME1 );

                    if(( StopTime  == StopDefault  || StopTime  == StopDefault  - TimeVariant ) &&
                       ( StartTime == StartDefault || StartTime == StartDefault - TimeVariant ))
                            return;

                } // End For Loop, Loop:

                LineCount[ @_Total ][ MouseOver ]  += 1;
                LineCount[ @_Count ][ MouseOver ]  += 1;

                if( LineCount[ @_Total ][ MouseOver ] < 1000 ) {
                    DrawColor   =  Colors[ 1 ][ MouseOver ];
                    DrawObject  =  TrendObject + DoubleToStr( MouseOver, 0 ) + " ";
                    DrawObject  =  DrawObject  + DoubleToStr( LineCount[ @_Total ][ MouseOver ], 0 );

                    DrawTrendLine ( DrawObject, StartDefault, StopDefault, Price, Price, DrawColor );

                } // End If, LineCount:
            } // End If, MouseOver;

    return;

} // End Routine Procedure, TrendLineCreator:




/*===============================================================================================|\
||                                                                                               ||
||  BoxLimits Routine Procedure              v1.00             Date 03.07.2012             KTL   ||
||                                                                                               ||
||  Returns:     returns the default price were the trend line will draw when mouse over.        ||
||                                                                                               ||
||  Purpose:     This procedure determines the limits to were the trend lines will be drawn.     ||
||                                                                                               ||
||  Note:        Global scope variables were used instead of diming static local which would     ||
||               not be seen out side of the this function as they need to keep there value and  ||
||               be seen out side of this function.                                              ||
||                                                                                               ||
||               This function sets the last high and last low price variables The last High     ||
||               Price must not be empty;                                                        ||
||                                                                                               ||
||               The Distance between the high price to the box top and the low price to the     ||
||               box bottom are set in the default attribute section. Also in the default is     ||
||               the switch to turn on and off the box's visibility. every thing works the       ||
||               same just you will not see the box.                                             ||
||                                                                                               ||
||        test code                                                                              ||
||        static datetime HoldTime = @_Empty;                                                    ||
||        HoldTime  = $_IFFn( HoldTime == @_Empty, TimeCurrent(), HoldTime );                    ||
||        HighPrice = $_IFFn( TimeCurrent() > HoldTime + 60, HighPrice + Default, HighPrice );   ||
||        LowPrice  = $_IFFn( TimeCurrent() > HoldTime + 60, LowPrice  - Default, LowPrice  );   ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    BoxLimits( string DrawBox, int TotalBars, double& LineLocation ) {
        int        BarShift     =   TotalBars + 1;
        int        HighBar      =   iHighest ( $_Pair, $_ChartScale, MODE_HIGH, BarShift, @_OpenBar );
        int        LowBar       =   iLowest  ( $_Pair, $_ChartScale, MODE_LOW,  BarShift, @_OpenBar );
        double     HighPrice    =   High[ HighBar ] + ExpandBox * Point;
        double     LowPrice     =   Low [ LowBar  ] - ExpandBox * Point;
        double     Default      =   DefaultPrice * Point;
        string     BoxView      =   DrawBox + "Box";
        datetime   HomeTime     =   Time[ 0 ] + ( 8 * $_ChartScale * 60 );
        datetime   FirstBar     =   Time[ BarShift - 1 ];

            LineLocation   =  HighPrice - Default;
            LastHighPrice  =  ObjectGet( BoxView, OBJPROP_PRICE1 );
            LastLowPrice   =  ObjectGet( BoxView, OBJPROP_PRICE2 );
            LastHighPrice  =  $_IFFn( LastHighPrice == @_Empty, HighPrice, LastHighPrice );
            LastLowPrice   =  $_IFFn( LastLowPrice  == @_Empty, LowPrice,  LastLowPrice  );

            DrawBoxObject( DrawBox, HomeTime, HighPrice, FirstBar, LowPrice );

    return;

} // End Routine Procedure, BoxLimits:




/*===============================================================================================|\
||                                                                                               ||
||  UpDateTrendLines Routine Procedure              v1.00             Date 03.07.2012      KTL   ||
||                                                                                               ||
||  Returns:     Return the linecount global array as it is passed by referanc.                  ||
||                                                                                               ||
||  Purpose:     Finds all existing trend lines that the system manages and extends them to      ||
||               mantain them to limits of the box.                                              ||
||                                                                                               ||
||  Parameters:  Object    --- The Programs Base Objcet name string.                             ||
||               LineCount --- The global array that holds the line count.                       ||
||               Colors    --- The global array that hold the different line colors.             ||
||               Bar       --- The number of bars in view on the current chart.                  ||
||                                                                                               ||
||  Note:        If the user did not extend the trend line to the limits of the box at the time  ||
||               it was layed out then this function will not have any effect on that line as    ||
||               it can not see it or control it in the ray code.                                ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    UpDateTrendLines( string Object, int& LineCount[][], color Colors[][], int Bar ) {
        int        Index          =   @_Empty;
        int        Count          =   @_Empty;
        int        Length         =   @_Empty;
        string     BoxObject      =   Object + "Box";
        string     TrendObject    =   Object + "Trend ";
        string     LineName       =   @_Clear;
        datetime   StartTime      =   @_Empty;
        datetime   StopTime       =   @_Empty;
        datetime   StartDefault   =   Time[ Bar - DefaultStart ];
        datetime   StopDefault    =   Time[ Bar - DefaultStop  ];
        color      DrawColor      =   @_Empty;

            for( Index = 1; Index <= 4; Index ++ )
                LineCount[ @_Count ][ Index ]  =  @_Empty;

            Length  =  StringLen( TrendObject );

            for( Count = ObjectsTotal(); Count > 0; Count -- ) {
                if( StringSubstr( ObjectName( Count ), 0, Length ) == TrendObject ) {
                    LineName    =  ObjectName( Count );
                    Index       =  StrToInteger( StringSubstr( LineName, Length, 1 ));
                    DrawColor   =  Colors[ 1 ][ Index ];
                    StartTime   =  ObjectGet( LineName, OBJPROP_TIME2  );
                    StopTime    =  ObjectGet( LineName, OBJPROP_TIME1  );

                    LineCount[ @_Count ][ Index ]  +=  1;

                    if( StopTime == StopDefault && StartTime == StartDefault )  continue;

                    RayTrendLine( LineName, BoxObject, DrawColor, StartTime, Colors );

                } // End If, StringSubstr:
            } // End For Loop, Count:

    return;

} // End Routine Procedure, UpDateTrendLines:




/*===============================================================================================|\
||                                                                                               ||
||  RayTrendLine Routine Procedure              v1.00             Date 03.03.2012          KTL   ||
||                                                                                               ||
||  Returns:     Returns the lines start time back to the calling procedure as it is past by     ||
||               referance.                                                                      ||
||                                                                                               ||
||  Purpose:     This is the function that does all the calculations to the veriest lines to     ||
||               extend them to the box limits and keep them in the right angles.                ||
||                                                                                               ||
||  Parameters:  Name      --- The current line name string.                                     ||
||               Box       --- The box naming string.                                            ||
||               Paint     --- The active color of the given trend line.                         ||
||               StartTime --- The line's start time.                                            ||
||               Tint      --- The global array containing all variations of line colors.        ||
||                                                                                               ||
||  Note:        ( StartTime > StopTime ) The start time must be larger then stop time or we     ||
||               get division by zero errors. Any lines draged out side of the box limits will   ||
||               be deleted also to elimiate a division by zero errors.                          ||
||                                                                                               ||
||               BarAdj is to account for the missing bars between fridays close and Sundays or  ||
||               Monday opening. When drawing lines accross the closing gap we get distortion    ||
||               of the trend line, do to the missing bars. the BarAdj veriable is calculated    ||
||               by the procedural call to he BlackHole() function. It need be done only once.   ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    RayTrendLine( string Name, string Box, color Paint, datetime& StartTime, color Tint[][] ){
        bool       Moved        =   False;
        int        BarAdjust    =   @_Empty;
        int        BarCount     =   @_Empty;
        int        BarToTime    =   @_Empty;
        int        BarToPrice   =   @_Empty;
        int        TradeDay     =   TimeDayOfWeek( StartTime );
        double     PriceAdj     =   @_Empty;
        double     HighPrice    =   ObjectGet( Box,  OBJPROP_PRICE1 );
        double     LowPrice     =   ObjectGet( Box,  OBJPROP_PRICE2 );
        double     StartPrice   =   ObjectGet( Name, OBJPROP_PRICE2 );
        double     StopPrice    =   ObjectGet( Name, OBJPROP_PRICE1 );
        double     TotalPrice   =   StartPrice - StopPrice;
        datetime   StopTime     =   ObjectGet( Name, OBJPROP_TIME1 );
        datetime   HomeTime     =   Time[ 0 ] + ( 8 * $_ChartScale * 60 );
        datetime   NewBarOpen   =   Time[ 0 ] + ( 7 * $_ChartScale * 60 );

            if( StartTime > StopTime ) {
                BarAdjust  =  $_IFFn( TimeDayOfWeek( StopTime ) > TradeDay, BarAdj, 0 );
                BarCount   =  ( StartTime - StopTime ) / ( $_ChartScale * 60 );
                PriceAdj   =  ( TotalPrice / ( BarCount - BarAdjust ));
                BarToTime  =  ( StartTime - HomeTime ) / ( $_ChartScale * 60 );

                if( StartPrice > HighPrice || StartPrice < LowPrice ) {
                    if(( StopPrice > HighPrice && StartPrice > HighPrice ) ||
                       ( StopPrice < LowPrice  && StartPrice < LowPrice  )) {
                            ObjectDelete( Name );

                    } else if( StartPrice != StopPrice ) {
                        Moved  =  True;
                        if( StartPrice > HighPrice ) {
                            BarToPrice  =  MathCeil(( StartPrice - HighPrice ) / PriceAdj );
                            StartTime   =  StartTime - ( BarToPrice * ( $_ChartScale * 60 ));
                            StartPrice  =  HighPrice;

                        } else if( StartPrice < LowPrice ) {
                            BarToPrice  =  MathCeil(( StartPrice - LowPrice ) / PriceAdj );
                            StartTime   =  StartTime - ( BarToPrice * ( $_ChartScale * 60 ));
                            StartPrice  =  LowPrice;

                        } // End If, StartPrice:
                    } // End If, StartPrice:

                } else if( HighPrice > LastHighPrice || LowPrice < LastLowPrice ) {
                    Moved  =  True;
                    if( StartPrice == LastHighPrice ) {
                        BarToPrice  =  MathCeil(( StartPrice - HighPrice ) / PriceAdj );
                        StartTime   =  StartTime - ( BarToPrice * ( $_ChartScale * 60 ));
                        StartPrice  =  HighPrice;

                    } else if( StartPrice == LastLowPrice ) {
                        BarToPrice  =  MathCeil(( StartPrice - LowPrice ) / PriceAdj );
                        StartTime   =  StartTime - ( BarToPrice * ( $_ChartScale * 60 ));
                        StartPrice  =  LowPrice;

                    } // End If, StartPrice:

                } else if( StartPrice != HighPrice || StartPrice != LowPrice ) {
                    if( StartTime > HomeTime || StartTime == NewBarOpen ) {
                        StartPrice  =  StartPrice - ( BarToTime * PriceAdj );
                        StartTime   =  HomeTime;

                        if( StartPrice < HighPrice && StartPrice > LowPrice )
                            Moved  =  True;

                    } else if( StartPrice == StopPrice && StartTime != HomeTime ) {
                        DivorceCourt( Name );

                    } // End If, StartTime:
                } // End If, StartPrice:

                if( Moved )
                    DrawTrendLine( Name, StartTime, StopTime, StartPrice, StopPrice, Paint );

                if( StartTime >= NewBarOpen || StartPrice == HighPrice || StartPrice == LowPrice )
                    TrendLineBrake( Name, HighPrice, LowPrice, Tint );

            } else if( StartTime <= StopTime ) {
                StartTime  =  StopTime + ( 20 * $_ChartScale * 60 );
                ObjectMove( Name, 1, StartTime, StartPrice );

            } // End If, StartTime:

    return;

} // End Routine Procedure, RayTrendLine:




/*===============================================================================================|\
||                                                                                               ||
||  TrendLineBrake Routine Procedure              v1.00             Date 03.03.2012        KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     This routine maintains the trend lines state that is active or broken.          ||
||                                                                                               ||
||  Parameters:  LineName  --- The current trend line string name.                               ||
||               HighPrice --- The high Price is the top limit to the box, the level that the    ||
||                                 line will be maintained too.                                  ||
||               LowPrice  --- The low price of the bottom of the box, the lower level that the  ||
||                                 line will be maintained too.                                  ||
||               Colors    --- The global array that contains all the varies trend line colors.  ||
||                                                                                               ||
||  Note:       Trend lines will expand to the box limits even after they are broken. If price   ||
||              returns back accross the line by more then the brake pips set in the default     ||
||              attribute section the line will re-establish itself as an active trend line.     ||
||                                                                                               ||
||              when the price is between the warning pip level and the pip brake level the line ||
||              will blink between the active color and the brake color as a visiual warning.    ||
||              When the line brakes it will appear as a broken line on the chart in a darken    ||
||              color.                                                                           ||
||                                                                                               ||
||              When a trend line is broken it will play the approperate sound wave, if the      ||
||              Play sound alert switch is turn on. It will only play the sound wave once,       ||
||              when the trend line is broken, how ever if the trend line get re-activeated by   ||
||              price returning over the line the sound function is reset to play again on the   ||
||              next brake of that line.                                                         ||
||                                                                                               ||
||              There is a mild rounding factory used to determine if the line is a RS or a      ||
||              trend line, this rounding does not affect the line drawing the line will still   ||
||              be drawn at its original price levels, which makes it some what difficault to    ||
||              make them level. we may need to use the rounded price levels to make it easier   ||
||              to construct RS lines.                                                           ||
||                                                                                               ||
||   See NOTE 2: in the 'Script Notes Section' consering the extra spacing in the arrow naming.  ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    TrendLineBrake( string LineName, double HighPrice, double LowPrice, color Colors[][] ) {
        int       Index       =   StrToInteger( StringSubstr( LineName, 34, 1 ));
        int       Condition   =   ObjectGet( LineName, OBJPROP_STYLE );
        int       Base        =   $_IFFn( Digits >= 4, 10000, 100 );
        double    HomePrice   =   ObjectGet( LineName, OBJPROP_PRICE2 );
        double    EndPrice    =   ObjectGet( LineName, OBJPROP_PRICE1 );
        double    ActiveEnd   =   NormalizeDouble( MathRound( HomePrice * Base ) / Base, Digits -1 );
        double    StaticEnd   =   NormalizeDouble( MathRound( EndPrice  * Base ) / Base, Digits -1 );
        double    Trend       =   ObjectGetValueByShift( LineName, 0 );
        double    WarnPIP     =   PipsWarning  * Point;
        double    BreakPIP    =   PipsBreaking * Point;
        double    SRType      =   $_IFFn( EndPrice + BreakPIP >= Bid, @_HighSR, @_LowSR );
        string    SRmarker    =   $_OverWrite( LineName, 28, "Arrow" ) + "    ";
        datetime  TimeZero    =   Time[ 0 ] - ( 1 * $_ChartScale * 60 );
        datetime  EndAt       =   ObjectGet( LineName, OBJPROP_TIME1 ) - ( 2 * $_ChartScale * 60 );
        datetime  StartAt     =   ObjectGet( LineName, OBJPROP_TIME2 );
        color     BlinkColor  =   ObjectGet( LineName, OBJPROP_COLOR );
        color     HoldColor   =   Colors[ @_Hold  ][ Index ];
        color     BreakColor  =   Colors[ @_Break ][ Index ];

            $_SwapState( BlinkColor, BreakColor, HoldColor );

            if( ActiveEnd > StaticEnd ) {
                if( StartAt < TimeZero ) {
                    ObjectSet( LineName, OBJPROP_STYLE, @_Broken   );
                    ObjectSet( LineName, OBJPROP_COLOR, BreakColor );

                } else if( Bid < Trend - BreakPIP  ) {
                    ObjectSet( LineName, OBJPROP_STYLE, @_Broken   );
                    ObjectSet( LineName, OBJPROP_COLOR, BreakColor );
                    if( Condition != @_Broken )
                        PlayWaves( SoundAlert, LineName, UPTrendBreak, Colors, 1 );

                } else if( Bid - WarnPIP <= Trend || Bid <= Trend + BreakPIP ) {
                    ObjectSet( LineName, OBJPROP_COLOR, BlinkColor );

                } else if( Bid > Trend + BreakPIP ) {
                    ObjectSet( LineName, OBJPROP_STYLE, @_Holding );
                    ObjectSet( LineName, OBJPROP_COLOR, HoldColor );
                    ReSetWave( LineName );

                } // End If, Bid:

            } else if( ActiveEnd < StaticEnd ) {
                if( StartAt < TimeZero ) {
                    ObjectSet( LineName, OBJPROP_STYLE, @_Broken   );
                    ObjectSet( LineName, OBJPROP_COLOR, BreakColor );

                } else if( Bid > Trend + BreakPIP ) {
                    ObjectSet( LineName, OBJPROP_STYLE, @_Broken   );
                    ObjectSet( LineName, OBJPROP_COLOR, BreakColor );
                    if( Condition != @_Broken )
                        PlayWaves( SoundAlert, LineName, DNTrendBreak, Colors, 2 );

                } else if( Bid + WarnPIP > Trend || Bid > Trend + BreakPIP ) {
                    ObjectSet( LineName, OBJPROP_COLOR, BlinkColor );

                } else if( Bid < Trend + BreakPIP ) {
                    ObjectSet( LineName, OBJPROP_STYLE, @_Holding );
                    ObjectSet( LineName, OBJPROP_COLOR, HoldColor );
                    ReSetWave( LineName );

                } // End If, Bid:

            } else if( ActiveEnd == StaticEnd ) {
                if( ObjectFind( SRmarker + "1" ) == $_MainWindow  ) {
                    if( Condition != @_Broken ) {
                        if( Bid > Trend + BreakPIP ) {
                            ObjectSet( LineName, OBJPROP_STYLE, @_Broken   );
                            ObjectSet( LineName, OBJPROP_COLOR, BreakColor );
                            PlayWaves( SoundAlert, LineName, SRResistance, Colors, 3 );

                        } else if( Bid + WarnPIP >= Trend || Bid >= Trend + BreakPIP ) {
                            ObjectSet( LineName, OBJPROP_COLOR, BlinkColor );

                        } else if( Bid + WarnPIP < Trend + BreakPIP ) {
                            ObjectSet( LineName, OBJPROP_STYLE, @_Holding  );
                            ObjectSet( LineName, OBJPROP_COLOR, HoldColor  );
                            ObjectSet( LineName, OBJPROP_TIME2, StartAt    );
                            ObjectMove( SRmarker + "1", 0, EndAt, EndPrice );
                            ReSetWave( LineName );

                        } // End If, Bid:

                    } else if( Condition == @_Broken ){
                        TerminateSR( LineName, SRmarker, @_HighSR, BreakColor );

                    } // End If, Bid:

                } else if( ObjectFind( SRmarker + "2" ) == $_MainWindow ) {
                    if( Condition != @_Broken ) {
                        if( Bid < Trend - BreakPIP ) {
                            ObjectSet( LineName, OBJPROP_STYLE, @_Broken   );
                            ObjectSet( LineName, OBJPROP_COLOR, BreakColor );
                            PlayWaves( SoundAlert, LineName, SRSupport, Colors, 4 );

                        } else if( Bid - WarnPIP <= Trend || Bid <= Trend - BreakPIP ) {
                            ObjectSet( LineName, OBJPROP_COLOR, BlinkColor );

                        } else if( Bid - WarnPIP > Trend - BreakPIP ) {
                            ObjectSet( LineName, OBJPROP_STYLE, @_Holding  );
                            ObjectSet( LineName, OBJPROP_COLOR, HoldColor  );
                            ObjectSet( LineName, OBJPROP_TIME2, StartAt    );
                            ObjectMove( SRmarker + "2", 0, EndAt, EndPrice );
                            ReSetWave( LineName );

                        } // End If, Bid:

                    } else if( Condition == @_Broken ) {
                        TerminateSR( LineName, SRmarker, @_LowSR, BreakColor );

                    } // End If, Bid:

                } else {
                    DrawMarkerSR( SRType, SRmarker, EndPrice, EndAt, HoldColor );

                } // End If, ObjectFind:
            } // End If, ActiveEnd:

    return;

} // End Routine Procedure, TrendLineBrake:




/*===============================================================================================|\
||                                                                                               ||
||  PlayWaves Routine Procedure                v1.00                Date 03.07.2012        KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     Plays sound wave file based on the type of trend line or support/resistance     ||
||               that has been broken. This routine will also record the last line name based    ||
||               on the type of line that was last broken, so we don't get repeated trigging     ||
||               of the same line.                                                               ||
||                                                                                               ||
||  Parameters:  PlayIT    --- This is the global true false switch to turn on and off sound.    ||
||               TrendLine --- The name of the trendline that price has triggered.               ||
||               WaveFile  --- Name of the wave file to play based on type of trendline broken.  ||
||               Type      --- The is the type of trendline that triggered the sound routine.    ||
||                                                                                               ||
||  Note:        LastSound[] is a global string array that holds the name of the last trendline  ||
||               of a given type that has triggered a sound wave, this is to prevent the repeat- ||
||               ing of the sound wave if the price bounces back and forth over the line.        ||
||                                                                                               ||
||               The sound wave will change from the one that was inputed if the arrow of that   ||
||               line, is colored in to match the trend line color. In which case, it will play  ||
||               the range brake out sound waves in stead. This only will happen if we have two  ||
||               marred lines were one is broken.                                                ||
||                                                                                               ||
||   See NOTE 2: in the 'Script Notes Section' consering the extra spacing in the arrow naming.  ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    PlayWaves( bool PlayIT, string TrendLine, string WaveFile, color tColor[][], int Type ) {
        int      Line        =   StrToInteger( StringSubstr( TrendLine, 34, 1 ));
        int      ArrowType   =   Type - 2;
        string   ArrowName   =   "    " + DoubleToStr( ArrowType, 0 );
        string   FindArrow   =   @_Clear;

            if( ArrowType > @_Empty ) {
                FindArrow  =  $_OverWrite( TrendLine, 28, "Arrow" ) + ArrowName;

                if( ObjectFind( FindArrow ) == $_MainWindow ) {
                    if( ObjectGet( FindArrow, OBJPROP_COLOR ) == tColor[ 1 ][ Line ] ) {
                        Type +=  2;
                        WaveFile   =  $_IFFs( Type == 5, RangeBOup, RangeBOdown );

                    } // End If, ObjectGet:
                } // End If, ObjectFind:
            } // End If, ArrowType:

            Line  =  $_IFFn( Type == @_Empty, @_Empty, Line );

            if( PlayIT && LastSound[ Type ][ Line ] != TrendLine )
                PlaySound( WaveFile );

            LastSound[ Type ][ Line ]  =  TrendLine;

    return;

} // End Routine Procedure, PlayWaves:




/*===============================================================================================|\
||                                                                                               ||
||  ReSetWave Routine Procedure                 v1.00                Date 03.07.2012       KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     Clears the sound wave array of the given line number so the line can tregger    ||
||               again. This is done just on the line that have been reset to there original     ||
||               state either by the user or the program.                                        ||
||                                                                                               ||
||  Parameters:  TrendLine --- The name of the trendline that will be reset to trigger agian.    ||
||                                                                                               ||
||  Note:        LastSound[][] is a global string array that holds the name of the last trend    ||
||               line of a given type that has triggered a sound wave, this is to prevent the    ||
||               repeating of the sound wave if the price bounces back and forth over the line.  ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    ReSetWave( string TrendLine ) {
        int   Index   =   @_Empty;
        int   Line    =   StrToInteger( StringSubstr( TrendLine, 34, 1 ));

            for( Index = 0; Index <= 7; Index ++ ) {
                if( LastSound[ Index ][ Line ] != TrendLine )   {   continue;   }
                    LastSound[ Index ][ Line ]  =  @_Clear;
                    break;

            } // End For Loop, Index:

    return;

} // End Rotine Procedure, ReSetWave:




/*===============================================================================================|\
||                                                                                               ||
||  TerminateSR Routine Procedure                 v1.00             Date 03.04.2012        KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     This function will terminate SR lines after they are breached. It also looks    ||
||               to see if the SR line was married to another line, it will terminate both       ||
||               lines.                                                                          ||
||                                                                                               ||
||  Parameters:  SubjTrend  --- This is the string name of the line.                             ||
||               SubjMarker --- This is the string name of the line marker.                      ||
||               SubjArrow  --- The arrow is the type of arrow applied to the trend line.        ||
||               Darken     --- This is the broken color of the current line.                    ||
||                                                                                               ||
||  Note:        When a SR line is broken it will no longer be maintained and will not get       ||
||               reactivated if price returns above it like that of trend lines. Once broken it  ||
||               is done. We can marry two SR lines that is one above price with one under price ||
||               to from a straddle define a range area. If one line is married to another both  ||
||               lines will be terminated in unison.                                             ||
||                                                                                               ||
||   See NOTE 2: in the 'Script Notes Section' consering the extra spacing in the arrow naming.  ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    TerminateSR( string SubjTrend, string SubjMarker, int SubjArrow, color Darken ) {
        int        Count        =   @_Empty;
        int        ArrowType    =   $_IFFn( SubjArrow == @_LowSR, @_HighSR, @_LowSR );
        int        LineCount    =   StrToInteger( StringSubstr( SubjTrend, 36, 4 )) + 1;
        double     SubjPrice    =   ObjectGet( SubjTrend, OBJPROP_PRICE1 );
        double     PairPrice    =   @_Empty;
        string     PairTrend    =   StringSubstr( SubjTrend,  0, 36 );
        string     PairArrow    =   DoubleToStr( SubjArrow, 0 );
        string     MateArrow    =   "    " + DoubleToStr( ArrowType, 0 );
        string     PairMarker   =   StringSubstr( SubjMarker, 0, 36 );
        string     TestArrow    =   PairMarker + DoubleToStr( LineCount, 0 ) + MateArrow;
        datetime   PassLine     =   ObjectGet( SubjTrend, OBJPROP_TIME2 );
        datetime   PairTime     =   @_Empty;
        datetime   SRbreak      =   Time[ 0 ] + ( 3 * $_ChartScale * 60 );
        color      PairMate     =   ObjectGet( SubjTrend, OBJPROP_COLOR );

            if( PassLine == SRbreak )   {   return;   }

            SubjMarker  =  SubjMarker + PairArrow;

            ObjectSet( SubjTrend, OBJPROP_TIME2, SRbreak );
            ObjectDelete( SubjMarker );

            if( PairMate == @_Single )   {   return;   }

                for( Count = 2; Count > 0; Count -- ) {
                    if( ObjectFind( TestArrow ) == @_Failed ) {
                        LineCount  =  LineCount  - 2;
                        TestArrow  =  PairMarker + DoubleToStr( LineCount, 0 ) + MateArrow;

                    } else {
                        PairTrend  =  PairTrend + DoubleToStr( LineCount, 0 );

                        if( ObjectFind( PairTrend ) == $_MainWindow ) {
                            PairPrice  =  ObjectGet( PairTrend,  OBJPROP_PRICE1 );

                            if(( ArrowType == @_HighSR && PairPrice > SubjPrice ) ||
                               ( ArrowType == @_LowSR  && PairPrice < SubjPrice )) {
                                    PairTime  =  ObjectGet( PairTrend, OBJPROP_TIME2 );

                                    if( PairTime > SRbreak ) {
                                        ObjectSet( PairTrend, OBJPROP_COLOR,   Darken );
                                        ObjectSet( PairTrend, OBJPROP_TIME2,  SRbreak );
                                        ObjectSet( PairTrend, OBJPROP_STYLE, @_Broken );

                                        ObjectDelete( TestArrow );

                                    } // End If, PairTime:
                            } // End If, ArrowType:
                        } // End If, ObjectFind:
                    } // End If, ObjectFind:
                } // End For Loop, Count:

    return;

} // End Routine Procedure, TerminateSR:




/*===============================================================================================|\
||                                                                                               ||
||  DeleteUnUsedArrows Routine Procedure             1.00              Date 03.04.2012     KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     Deletes un-used arrows that have not matching trend line.                       ||
||                                                                                               ||
||  Parameters:  None                                                                            ||
||                                                                                               ||
||  Note:        We can delete any line at any time after it is drawn. If we delete a RS line    ||
||               the arrow that is left behine will be removed by this routine. It also looks    ||
||               to see if the line just deleted had a mate (Married) and if so it will dissolve ||
||               the marrage and the mate will then be considered as being single.               ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    DeleteUnUsedArrows() {
        int      Count         =   @_Empty;
        int      ArrowType     =   @_Empty;
        int      ArrowLength   =   @_Empty;
        double   StartPrice    =   @_Empty;
        double   StopPrice     =   @_Empty;
        string   MatchLine     =   @_Clear;
        string   ArrowFound    =   @_Clear;
        color    ArrowMated    =   @_Empty;

            for( Count = ObjectsTotal(); Count > 0; Count -- ) {
                if( StringSubstr( ObjectName( Count ), 28, 6 ) == "Arrow " ) {
                    ArrowFound   =  ObjectName( Count );
                    ArrowLength  =  StringLen( ArrowFound ) -1;
                    ArrowType    =  StrToInteger( StringSubstr( ArrowFound, ArrowLength, 1 ));
                    ArrowMated   =  ObjectGet( ArrowFound, OBJPROP_COLOR );
                    MatchLine    =  $_OverWrite( ArrowFound, 28, "Trend" );
                    MatchLine    =  StringTrimRight( StringSubstr( MatchLine, 0, 41 ));
                    StartPrice   =  ObjectGet( MatchLine, OBJPROP_PRICE2 );
                    StopPrice    =  ObjectGet( MatchLine, OBJPROP_PRICE1 );

                    if( ObjectFind( MatchLine ) != $_MainWindow || StartPrice != StopPrice ) {
                        if( ArrowMated != @_Single )
                            FindMate( ArrowType, ArrowFound, ArrowMated, @_Single );

                        ObjectDelete( ArrowFound );

                    } // End If, ObjectFind:
                } // End If, StringSubstr:
            } // End For Loop, Count:

    return;

} // End Routine Procedure, DeleteUnUsedArrows:




/*===============================================================================================|\
||                                                                                               ||
||  DivorceCourt Routine Procedure                v1.00                Date 03.06.2012     KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     To break the pairing of two SR lines if the user moves one paired line to the   ||
||               same side of the bid as its mate.                                               ||
||                                                                                               ||
||  Parameters:  DivorceArrow --- This is the arrow that was moved.                              ||
||                                                                                               ||
||  Note:        If the user moves a paired line but does not place it on the same side of the   ||
||               bid as his mate this procedure will not be called. Only if both lines in a      ||
||               pair are on the same side of the bid will this be called. If later one of       ||
||               lines are later seperated to both sides of the bid they will get re married     ||
||               to each other again.                                                            ||
||                                                                                               ||
||               This will remove the arrow if one of the lines are pulled from the box limit    ||
||               if it is married it will brake the marrage as well.                             ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    DivorceCourt( string RemoveMarker ) {
        int       ArrowLength   =   StringLen( RemoveMarker );
        int       Index         =   @_Empty;
        string    Marker        =   $_OverWrite( RemoveMarker, 28, "Arrow" ) + "    ";
        string    MarkerType    =   @_Clear;
        color     ArrowMated    =   @_Empty;

            for( Index = 1; Index <= 2; Index ++ ) {
                MarkerType  =  Marker + DoubleToStr( Index, 0 );

                if( ObjectFind( MarkerType ) == $_MainWindow ) {
                    ArrowMated  =  ObjectGet( MarkerType, OBJPROP_COLOR );

                    if( ArrowMated != @_Single )
                        FindMate( Index, MarkerType, ArrowMated, @_Single );

                    ObjectDelete( MarkerType );
                    break;

                } // End If, ObjectFind:
            } // End For Loop, Index:

    return;

} // End Routine Procedure, DivorceCourt:




/*===============================================================================================|\
||                                                                                               ||
||  DrawMarkerSR Routine Procedure             v1.00                 Date 03.04.2012       KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     This routine will place the arrow at the end of RS lines. It also looks to see  ||
||               if the line should be married to a mate.                                        ||
||                                                                                               ||
||  Parameters:  TypeSR   --- This is the type of arrow to draw.                                 ||
||               SRarrow  --- This is the string name to be given the arrow.                     ||
||               EndPrice --- The end price of the line it is attached to.                       ||
||               EndTime  --- The end time of the line it is attached to.                        ||
||               Tint     --- This is the color that the arrow will be colored to if the line    ||
||                                is considered married.                                         ||
||                                                                                               ||
||  Note:        These arrows will not show if the switch ShowSRmarks is turned off in the       ||
||               default attribute section. The arrows are still drawn but not visiable if the   ||
||               switch is off. Any marraged lines will still be in effect.                      ||
||                                                                                               ||
||               This routine Checks to see if there are two arrows that may exist on the chart. ||
||               When a line is moved from above the bid price to below then we need to change   ||
||               the arrow type from 1 to 2, and vise verser. There fore this routine not only   ||
||               creates the lines arrow but will delete any other arrows that have the same     ||
||               arrow code on the operset side of the bid line.                                 ||
||                                                                                               ||
||   See NOTE 2: in the 'Script Notes Section' consering the extra spacing in the arrow naming.  ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    DrawMarkerSR( int TypeSR, string SRarrow, double EndPrice, datetime EndTime, color Tint ) {
        int      FindMarker    =   @_Empty;
        int      TestReverse   =   TypeSR;
        string   TestArrow     =   @_Clear;
        string   TypeName      =   DoubleToStr( TypeSR,  0 );
        color    HasMate       =   @_UnKnown;

            SRarrow     =  SRarrow + TypeName;
            FindMarker  =  ObjectFind( SRarrow );
           // EndTime     =  EndTime - ( 2 * $_ChartScale * 60 );

            $_SwapState( TestReverse, @_HighSR, @_LowSR );
            TestArrow  =  StringSubstr( SRarrow, 0, 41 ) + DoubleToStr( TestReverse, 0 );
            if( ObjectFind( TestArrow ) == $_MainWindow )   {   ObjectDelete( TestArrow );   }

            if( FindMarker == $_MainWindow )
                if( ObjectGet( SRarrow, OBJPROP_TIME1  ) != EndTime ||
                    ObjectGet( SRarrow, OBJPROP_PRICE1 ) != EndPrice ) {
                        HasMate  =  ObjectGet( SRarrow, OBJPROP_COLOR );
                        ObjectDelete( SRarrow );
                        FindMarker  =  @_Failed;

                } // End If, FindMarker:

            if( FindMarker != $_MainWindow ) {
                ObjectCreate ( SRarrow, OBJ_ARROW, $_MainWindow,
                                                 EndTime, EndPrice );
                    ObjectSet( SRarrow, OBJPROP_BACK,   UnderPrice );
                    ObjectSet( SRarrow, OBJPROP_ARROWCODE,  TypeSR );

                if( HasMate == @_UnKnown )  FindMate( TypeSR, SRarrow, HasMate, Tint );
                    ObjectSet( SRarrow, OBJPROP_COLOR,     HasMate );
                    ObjectSet( SRarrow, OBJPROP_TIMEFRAMES, @_Hide );

            } // End If, FindMarker:

            if( ShowSRmarks )
                ObjectSet( SRarrow,  OBJPROP_TIMEFRAMES, @_Show );

    return;

} // End Routine Procedure, DrawMarkerSR:




/*===============================================================================================|\
||                                                                                               ||
||  FindMate Routine Procedure                 v1.00                Date 03.05.2012        KTL   ||
||                                                                                               ||
||  Returns:     Returns the color of the arrow if a mate has been found as it that was past by  ||
||               referance.                                                                      ||
||                                                                                               ||
||  Purpose:     This routine is used to find if the RS line has a mate and to mark both as      ||
||               being married. This is done by coloring the arrows in with the color of the     ||
||               line. If no mate is found the arraw remains hollow.( uncolored )                ||
||                                                                                               ||
||  Parameters:  SubjArrow  --- The type of arrow the subject line has.                          ||
||               SubjMarker --- The string name of the arrow of the subject.                     ||
||               HasMate    --- The return value (color) of if a mate has been found.            ||
||               Mates      --- The color to paint the arrows to distinguish the two lines as    ||
||                                 being paired together.                                        ||
||                                                                                               ||
||  Note:        The mating is done by finding a line on the opperset side of price of the same  ||
||               dimention as the subject line. only one line will be married to a line, bigamy  ||
||               is not permitted nor is same arrow marriages. That is both lines can not be on  ||
||               the same side of price.                                                         ||
||                                                                                               ||
||   See NOTE 2: in the 'Script Notes Section' consering the extra spacing in the arrow naming.  ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    FindMate( int SubjArrow, string SubjMarker, color& HasMate, color Mates ) {
        int        ArrowType    =   $_IFFn( SubjArrow == @_LowSR, @_HighSR, @_LowSR );
        int        Count        =   @_Empty;
        int        LineCount    =   StrToInteger( StringSubstr( SubjMarker, 36, 4 )) + 1;
        double     SubjPrice    =   ObjectGet( SubjMarker, OBJPROP_PRICE1 );
        double     MatePrice    =   @_Empty;
        string     MateType     =   StringSubstr( SubjMarker, 33,  3 );
        string     MateTrend    =   $_OverWrite( SubjMarker, 28, "Trend" ) + MateType;
        string     MateArrow    =   "    " + DoubleToStr( ArrowType, 0 );
        string     MateMarker   =   StringSubstr( SubjMarker, 0, 36 );
        string     TestArrow    =   MateMarker + DoubleToStr( LineCount, 0 ) + MateArrow;

            for( Count = 2; Count > 0; Count -- ) {
                if( ObjectFind( TestArrow ) == $_MainWindow ) {
                    if( ObjectGet( TestArrow, OBJPROP_COLOR ) == Mates ) continue;

                    MateMarker  =  TestArrow;
                    MatePrice   =  ObjectGet( MateMarker, OBJPROP_PRICE1 );
                    SubjPrice   =  ObjectGet( SubjMarker, OBJPROP_PRICE1 );

                    if(( ArrowType == @_HighSR && MatePrice > SubjPrice ) ||
                       ( ArrowType == @_LowSR  && MatePrice < SubjPrice )) {
                            ObjectSet( MateMarker, OBJPROP_COLOR, Mates );
                            HasMate  =  Mates;

                    } // End If, ArrowType:

                } else {
                    LineCount  =  LineCount  - 2;
                    TestArrow  =  MateMarker + DoubleToStr( LineCount, 0 ) + MateArrow;
                    HasMate    =  @_Single;

                } // End If, ObjectFind:
            } // End For Loop, Count:

    return;

} // End Routine Procedure, FindMate:




/*===============================================================================================|\
||                                                                                               ||
||  PollMouse Routine Procedure            v2.20            Date 02.04.2010             KTL      ||
||                                                                                               ||
||  Returns:     Returns the mouse location in the parameter Mouse which is passed byref.        ||
||                                                                                               ||
||  Purpose:    To see if the mouse is located over the trend line Crayons. The dll that is      ||
||              used to run this function was created by:                                        ||
||                     Berkers Trading, he can be reached at:    "http://quotar.com"             ||
||                                                                                               ||
||  Parameters:  Mouse --- this parameter is empty when passed and the mouse location is then    ||
||                         returned within this variable.                                        ||
||                                                                                               ||
||  Note:        The zero element of the array MouseXY[] is the xCord and the one element is     ||
||               the zCord.                                                                      ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    PollMouse( int& Mouse ) {
        int   CID       =   StrToInteger( $_ControlID );
        int   Pen       =   @_Empty;
        int   Xcord     =   240;
        int   MouseXY  [ 2 ];

            MT4_ScreenToClient( CID, MouseXY );

            if(( MouseXY[ 1 ] > 5     && MouseXY[ 1 ] <  25 ) &&
               ( MouseXY[ 0 ] > Xcord && MouseXY[ 0 ] < 365 )) {

                for( Pen = 1; Pen <= 4; Pen ++, Xcord += 30 ) {
                    if( MouseXY[ 0 ] > Xcord )   {   Mouse  =  Pen;     }
                    if( MouseXY[ 0 ] >   365 )   {   Mouse  =  @_Empty;   }

                } // End For Loop, Pen:
            } // End If, MouseXY:

    return;

} // End Routine Procedure, PollMouse:




//
//  GRAPHIC INTERFACE: 




/*===============================================================================================|\
||                                                                                               ||
||  DrawCrayon GUI Procedure                   v1.00                  Date 02.12.2012      KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     This procedure draws the color crayons at the top of the price chart. It will   ||
||               place the name of the program under the crayons, and place the copy right label ||
||               at the lower left corner of the price chart.                                    ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    DrawCrayon( string Object, int Window, color Colors[][] ) {
        int      Count        =   @_Empty;
        int      xCord        =   235;
        string   Crayons      =   Object + "Crayons ";
        string   Version      =   "v" + StringSubstr( @_VersionNumber, 0, 4 );
        string   Name         =   @_ProgramName + "   " + Version  + "   ( Beta )";
        string   Rights       =   @_CopyRight + "    " + @_Author + "    " + @_CompanyName;
        string   NameObject   =   Object + "Name";
        string   CopyObject   =   Object + "Copy";
        string   DrawObject   =   @_Clear;
        string   Fonts        =   "Wingdings 2";
        color    DrawColor    =   @_Empty;

            for( Count = 1; Count <= 4; Count ++, xCord += 33 ) {
                DrawObject  =  Crayons + DoubleToStr( Count, 0 );
                DrawColor   =  Colors[ 1 ][ Count ];

                if( ObjectFind( DrawObject ) != Window )
                    Draw( DrawObject, Window, "$", 20, Fonts, DrawColor, 0, 0, xCord, 0, True );

            } // End For Loop, Count:

            if( ObjectFind( NameObject ) != Window )
                Draw( CopyObject, Window, Rights, 7, "Arial", @_Text, 2, 0, 2, 1, False );

            if( ObjectFind( NameObject ) != Window )
                Draw( NameObject, Window, Name, 7, "Arial", @_Text, 0, 0, 220, 22, False );

    return;

} // End GUI Procedure, DrawCrayon:




/*===============================================================================================|\
||                                                                                               ||
||  DrawBoxObject GUI Procedure                 v1.00                 Date 02.29.2012      KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     This will draw the box arround the chart price bars. It will also draw the      ||
||               Prompt Zone label.                                                              ||
||                                                                                               ||
||  Note:        This procedure will draw the box no matter if the drawbox switch is off in the  ||
||               default attribut section, the Drawbox switch will just hide it from view, we    ||
||               need the box to calculate the extreams that the lines will be maintained to.    ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    DrawBoxObject( string Object, datetime Home, double PriceH, datetime First, double PriceL ) {
        double     Center       =   (( PriceH - PriceL ) / 2 ) + PriceL;
        string     PromptName   =   "PROMPT ZONE";
        string     ZoneObject   =   Object + " Zone";
        string     BoxObject    =   Object + "Box";
        datetime   Zone         =   Time[ 0 ] + ( 3 * $_ChartScale * 60 );

            if( ObjectFind( BoxObject ) == $_MainWindow ) {
                ObjectMove( BoxObject,  0, Home,  PriceH );
                ObjectMove( BoxObject,  1, First, PriceL );
                ObjectMove( ZoneObject, 0, Zone,  Center );

            } else {
                ObjectCreate ( BoxObject, OBJ_RECTANGLE, $_MainWindow,
                                          Home, PriceH, First, PriceL );
                    ObjectSet( BoxObject, OBJPROP_BACK,         False );
                    ObjectSet( BoxObject, OBJPROP_COLOR,   @_BoxColor );
                    ObjectSet( BoxObject, OBJPROP_TIMEFRAMES,  @_Hide );

                ObjectCreate ( ZoneObject, OBJ_TEXT, $_MainWindow,
                                                         Zone, Center );
                ObjectSetText( ZoneObject, PromptName,             10 );
                    ObjectSet( ZoneObject, OBJPROP_BACK,         True );
                    ObjectSet( ZoneObject, OBJPROP_COLOR, @_WaterMark );
                    ObjectSet( ZoneObject, OBJPROP_ANGLE,        90.0 );
                    ObjectSet( ZoneObject, OBJPROP_TIMEFRAMES, @_Hide );

            } // End If, ObjectFind:

                if( ShowBox ) {
                    ObjectSet( BoxObject,  OBJPROP_TIMEFRAMES, @_Show );
                    ObjectSet( ZoneObject, OBJPROP_TIMEFRAMES, @_Show );

                } // End If, ShowBox:

    return;

} // End GUI Procedure, DrawBoxObject:




/*===============================================================================================|\
||                                                                                               ||
||  DrawTrendLine GUI Procedure                 v1.00                 Date 02.28.2012      KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     Draws the original trend lines and it is used to redraw them in the management  ||
||               of the trend lines.                                                             ||
||                                                                                               ||
||  Parameters:  Line   --- The line string name.                                                ||
||               Time1  --- The start time of the trend line.                                    ||
||               Time2  --- The end time of the trend line.                                      ||
||               Price1 --- The start price of the trend line.                                   ||
||               Price2 --- The end price of the trend line.                                     ||
||               Tint   --- The active color of the trend line.                                  ||
||                                                                                               ||
||  Note:        None                                                                            ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    DrawTrendLine( string Line, datetime Time1, datetime Time2,
                                                double Price1, double Price2, color Tint ) {

            if( ObjectFind( Line ) == $_MainWindow )   {   ObjectDelete( Line );   }

            ObjectCreate ( Line, OBJ_TREND, $_MainWindow,
                           Time2, Price2, Time1,   Price1 );
                ObjectSet( Line, OBJPROP_BACK, UnderPrice );
                ObjectSet( Line, OBJPROP_RAY,       False );
                ObjectSet( Line, OBJPROP_COLOR,      Tint );

    return;

} // End GUI Procedure, DrawTrendLine:




/*===============================================================================================|\
||                                                                                               ||
||  DeActivateCrayons GUI Procedure               v1.00                Date 03.10.2012     KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     This program will not run if theres no incoming ticks. If the systme is offline ||
||               or the broker is closed for the weekend the program will notify the user with a ||
||               label on top of the chart window with the word "DE-ACTIVATED" in stead of the   ||
||               crayons.                                                                        ||
||                                                                                               ||
||  Parameters:  Object --- This is the program ID.                                              ||
||                                                                                               ||
||  Note:        None.                                                                           ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    DeActivateCrayons( string Object ) {
        string   Window      =   DoubleToStr( $_MainWindow, 0 );
        string   ActObject   =   "5.73 " + Object + Window + " Line Creator De-Active";
        string   OutLine     =   "DE-ACTIVATED";
        string   Font        =   "Arial Black";

            if( ObjectFind( ActObject ) != $_MainWindow )
                Draw( ActObject, Window, OutLine, 12, Font, Maroon, 0, 0, 230, 1, False );

    return;

} // End GUI Procedure, DeActivateCrayons:




/*===============================================================================================|\
||                                                                                               ||
||  Draw Routine Procedure              v1.00             Date 01.21.2009               KTL      ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     This is a general label drawing function to cut down on coding time and length. ||
||                                                                                               ||
||                                                                                               ||
||  Parameters:  Name   --- Name given the graphic object.                                       ||
||               Window --- The window which it will appear.                                     ||
||               Text   --- Text label.                                                          ||
||               fSize  --- font size.                                                           ||
||               Font   --- font type.                                                           ||
||               Color  --- color of output.                                                     ||
||               Corner --- which corner that the output will be anchored to.                    ||
||               Angle  --- the angle to apply to the object.                                    ||
||               Xcord  --- X cordinate.                                                         ||
||               Ycord  --- Y cordinate.                                                         ||
||               Back   --- background or forground imput true or false.                         ||
||                                                                                               ||
||  Note:        When using this function all imputs must be given even if the MT defaults are   ||
||               used, or this function will throw an error.                                     ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    Draw( string N, int W, string T, int S, string F, int C, int K, int A, int X, int Y, int B ) {

             if( ObjectFind( N ) == W ) ObjectDelete( N );
              ObjectCreate ( N, OBJ_LABEL, W,      0, 0 );
              ObjectSetText( N, T, S,              F, C );
                  ObjectSet( N, OBJPROP_CORNER,       K );
                  ObjectSet( N, OBJPROP_ANGLE,        A );
                  ObjectSet( N, OBJPROP_XDISTANCE,    X );
                  ObjectSet( N, OBJPROP_YDISTANCE,    Y );
                  ObjectSet( N, OBJPROP_BACK,         B );

    return;
} // End Routine Procedure, Draw:




/*===============================================================================================|\
||                                                                                               ||
||  $_ClearAllGraphics GUI Procedure            v2.10         Date 11.11.2009          KTL       ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  parameters:  NameObject --- This is a string that contains both the programs ID and its      ||
||                              three letter program symbol.                                     ||
||                                                                                               ||
||  Purpose:     This will remove all objects that the program created. Any objects created      ||
||               by other sources will not be removed. It will remove all Global Variables       ||
||               that were created by this system as well.                                       ||
||                                                                                               ||
||               Each copy of each program has full knowledge of its own objects and will not    ||
||               remove any objects that were created by any other sources or by any other       ||
||               copies of this same program applied to other currency pairs as all copies are   ||
||               Uniquely Identified and will only remove its own objects.                       ||
||                                                                                               ||
||   Note:       This function has been updated to include the use of page numering in all       ||
||               graphic nameing. It will also clear any of the older graphics which donot use   ||
||               page numbering to be reverse compatable.                                        ||
||                                                                                               ||
||               $_ClearAllGraphics ( $_ProgramObject );                                         ||
||                                                                                               ||
||               This will remove all owned Objects and Switchs plus Globals that were created   ||
||               by this program from all window plains not just the window the program was      ||
||               attached to. But will not clear the Registery entry nor Run Time Serial but     ||
||               will removes the Shared: Object.                                                ||
||                                                                                               ||
||               The objects naming method;                                                      ||
||                    ! 1.11 999 XXX 9 Group Type [Type[ Class [ SubClass]]                      ||
||                                                                                               ||
||               the first carriter is a tag number to show main positioning. The '!' is a page  ||
||               tagged to show or not show under the price layer, the '~' is the page tag to    ||
||               apply the graphics above all else. NO other graphics will appear that includes  ||
||               price itself. This tag is used for creating graphic applications.               ||
||               The first 4 digits includeing the point is the page and layering numbers.       ||
||               The next 3 digit number which follows a blank space is the Unique ID for the    ||
||               program that created the given object. The 3 letters that follow one blank      ||
||               space is the system symbol of the creating Program. The next single number is   ||
||               the window number. The next part is a string which is the Group name which can  ||
||               be of any length but must be unique from all others group names. The Type and   ||
||               class are optional and used to break down the group into different Types and    ||
||               Classes. A Group can how ever consist of only one object were not Types or      ||
||               Class is needed. ONLY the owner of an object can delete it.                     ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    $_ClearAllGraphics( string NameObject ) {
        int   Count          =   @_Empty;
        int   ObjectLength   =   StringLen( NameObject );

            for( Count = ObjectsTotal(); Count >= 0; Count -- ) {
                if( StringSubstr( ObjectName( Count ), 0, ObjectLength ) == NameObject ) {
                    ObjectDelete( ObjectName( Count )); // CN!{contains no page numbers}:

                } else if( StringSubstr( ObjectName( Count ), 5, ObjectLength ) == NameObject ) {
                    ObjectDelete( ObjectName( Count )); // CN!{contains page numbers}:

                } else if( StringSubstr( ObjectName( Count ), 7, ObjectLength ) == NameObject ) {
                    ObjectDelete( ObjectName( Count )); // CN!{contains a tagged page number}:

                } // End If, StringSubstr:
            } // End For Loop, Count:

            for( Count = GlobalVariablesTotal(); Count >= 0; Count -- ) {
                if( StringSubstr( GlobalVariableName( Count ), 0, ObjectLength ) == NameObject )
                    GlobalVariableDel( GlobalVariableName( Count ));

            } // End For Loop, Count:

    return;

} // End GUI Procedure, $_ClearAllGraphics:




/*===============================================================================================|\
||                                                                                               ||
||  $_DeleteGraphicPage GUI Procedure            v1.00         Date 01.23.2010           KTL     ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     To delete graphics based on Page Layering. Only graphics that match the page    ||
||               number will be removed.                                                         ||
||                                                                                               ||
||  Parameters:  Page --- The page numbering. this can include just the page number or any part  ||
||                        of its layers and sub layers.                                          ||
||                                                                                               ||
||  Note:                                                                                        ||
||               This will remove objects by graphic page numbers, here a program CAN remove     ||
||               other graphics that it did not create as all graphics that matches the page     ||
||               will be removed. It doenot matter which window plan that they may appear in,    ||
||               so long as the Page matches. The imput can be stated as example '5' for the     ||
||               deletion of the complete page. Or as in '5.5' to delete just layer 5 of page    ||
||               Page 5. Now if the imput is '5.53' then just the sub layer 3 will be deleted.   ||
||                                                                                               ||
||  Example:     $_DeleteGraphicPage( 8.5 ); This will delete layer 5 and all its sub layers,    ||
||               if any, of graphic page 8.                                                      ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    $_DeleteGraphicPage( double Page ) {
        string  GraphicPage   =   StringTrimLeft( DoubleToStr( Page, 1 ));
        int     Characters    =   StringLen( GraphicPage );
        int     Count         =   @_Empty;

            for( Count = ObjectsTotal(); Count > 0; Count -- )
                if( StringSubstr( ObjectName( Count ), 0, Characters ) == GraphicPage )
                    ObjectDelete( ObjectName( Count ));

    return;

} // End GUI Procedure, $_DeleteGraphicPage:




//
#define                                DOCUMENTATION~DIVISION                                    90
/*  PURPOSE AND SCOPE: 




    This program is designed as a tool, to supply trend lines to the user when s/he mouses over
    one of the crayons at the top of the chart window. When mouseing over one of the caryons the
    program will apply a short line in the chart window, which can be extended and place as the
    users require. Support and resistance line can also be drawn by keeping the trend line level,
    that is, as a horizontal line. The trend line will act as support or resistance depending
    on which side of price it is placed.

    The ability of having both a support and a resistance line operate as a pair in straddling
    price in a range is also possible. There are some rules that must be followed to apply
    this function. When two lines are married ( paired ) they will operate as one. If one gets
    broken then price would be considered to of broken out of the range, as a result, both lines
    will be considered as broken that is price has broken out of that range.

    The program has the ability to play sound waves (if enable ) when one of these lines has
    been broken. The sound wave will be in relations to the type of trend line and the direct-
    tion of price movement.

    This code is available in an include format so one can add this indicators functionality
    to any existing program. It makes no difference which type of code file one adds the
    include file too, that is another indicator or EA. It can be added to a script file if
    the script is designed with a continuing loop function. This indicator uses no buffers
    and has no indicator array output. Its total out put is in the form of graphic objects
    applied to the main chart window. As such, this Indicator can be attached to any window
    as it can controls its graphics from any open window its attached to. To use the include
    file format, read the section on the include file below,

    This code was supplied in a compiled .ex4 form as well for the ones that are not able to 
    to work with MT Editor.




    The program has some limitation.
        It will only monitor trend lines that are drawn inside or drawn through the price box
        and extended outside it by dragging the active end of it pass the limits of the box.
        Any trendline not extending to the limits of the box will not be seen by the program
        and can not be maintained by it.

        Any trend line that is drawn or dragged totally outside the box will be deleted. This
        was done because the line will have no pratical value if it doesnot cross or have the
        ability to cross price in some fastion.

        If you try to reverse the trend line, that is, drag the active end and place it behine
        the static end, the program will undue it by flipping it forward. Any line were the
        active end is earier in time then the static end will have cause a division by zero
        error. Therefore, the program will not permit the user to reverse any lines.

        There are no difference between the different colors of the trend lines, they will all
        act the same, with the exception of lines that are married. Different colors are supplied
        to give the user discregtion of usage in appling them.

        The code can not place and or modify orders nor act as stops levels. This ability can
        be coded in this program as the different colored lines can represent different actions
        to be preformed. There is an array that tracks all line numbering, as well, but serves
        no pratical purpose in this code currently. Between the numbering and the line colors
        one should be able to easily add trade functions if so desired.

        Because this program requires incoming ticks to opperate it will not work offline nor
        online if your borker is closed for the weekend. This program will also re-act slowly
        when market activity is slow for the same reason. It needs incoming ticks to read the
        action of your mouse, without a tick your mouse can not be read and no lines can be
        generated. The program will notify the user if it can not run because there is no incoming
        ticks with a label on top of the chart window with the word "DE-ACTIVATED" in stead of
        the crayons. If one is opperating this program along side a tick generate the limitation
        in receiving incomeing ticks is eleminated how ever you still need to be connected to
        the inter net for the program to function.

        There is a limit as to how many lines that can be drawn. That limit is 9,999 lines of
        each color of lines. The limit is large that no user need to consern them self of
        running out of lines. The limit is needed to limit the search for line numbering.





  FUNCTION OF PROGRAM: 




    DEFAULT PARAMETERS:
        This program has no user imputs displayed in the indicator dialog box, all parameters are
        programed within the code. If one wishes to alter the proformance of the indicator s/he
        must change the default values as found in the 'Default Attribute Section' of the code
        and re-conpile the code ( see also; NOTE 1: in the 'Script Notes Section' below ). These
        include;

            ShowBox, Default value is; True.
                This switch will turn on or off the visiability of the price box on the chart.
                This box object is drawn no matter the setting, the switch just makes the box's
                visiable or non visiable. The box is still drawn as it is needed by the code to
                assess which trend lines it has under its control. If one removes the box drawing
                code from the program, it will cease to operate. This box should be used till the
                user has a working knowladge of the program.

            ShowSRmarks, Default value is; True.
                This turns on and off the Support and Resistance Arrows that appear to the left
                of a line that is recognize by the program as a support or resistance line. The
                arrows are still drawn but their visiability is hiden. These arrows are used by
                the program to determine the type of line it is. Removeing the arrow code from
                the program will prevent the program to distinguish between trend lines and S/R
                lines. It is suggested that this be left on as an aide to the user.

            UnderPrice, Default value is; False.
                This is a switch to place the trend lines above or below the price bars. The
                Default is to place them on top of price.

            SoundAlert, Default value is; True.
                This is a switch to turn on and off the playing of sound waves ( PlaySound()
                function ) when a trendline is broken. Any sound waves that are called within
                the start function are not stopped, only the sound alerts that are triggered
                by the trendlines are effected by this parameter.

            @_Refresh, Default value is; True.
                This switch is a stub line to 'Refresh the Graphic Display'. The main part of
                this indicator was taken for another larger works of the author and this switch
                was added to make things compatable between the codes. It should be left as true
                or the user will have un-used objects on the price chart. The operation of the
                S/R lines could also be effected if it is turned off.

            DefaultStart, Default value is; 85. No varifications are made to this imput.
                This parameter determines the default starting position (Bar count) of the 
                trend line output when the user mouses over a crayon. This value is measured
                from the left side of the chart.

            DefaultStop, Default value is; 60. No varifications are made to this imput.
                This parameter determines the Default stop position (Bar count) of trend line
                output. This value is based on bar count from the left side of the chart window.

            ExpandBox, Default value is; 7. A value of 5 to 15 is required.
                This is the Pip value as measured in real pips (whole pips) that the program will
                add to the high and low prices to place the box on the chart. Increasing is value
                will add more space between the high and low prices and the borders of the box.
                This will self adjusted for 4/5 digit brokers. Any input here above or below the
                required range will default to the extream of the range, That is if you put the
                value of 20, the program will substitute it with 15.

            PipsWarning, Default value is; 2. A value of 1 to 10 is required.
                This is the number of pips (whole pips) to start warning of a line break. The
                program will start flashing the trend line when price approches the line. The
                value of this parameter will determine at which point it will start to warn the
                user of a pending line brake. If the trend line has already been broken this value
                is used to flash the trend line to warn that the break of the trend line may of
                been a false break. The difference here is that the line will blink as a broken
                line not a solid one as in the first case. This will self adjusted for 4/5 digit
                brokers. Any input here above or below the required range will default to the
                extream of the range, That is if you put the value of zero, the program will
                substitute it with 1.

            PipsBreaking, Default value is; 2. A value of 1 to 10 is required.
                This is the number of pips (whole pips) to determine that a line has been broken.
                The brakage of a line occures only after price has breached the line by a set
                number of pips. This value is determined by this parameter. It can not be set to
                zero, as it will cause the line to set and reset itself and trigger repeated sound
                alerts. When price breaks throu the trendline by this value it turns the line a
                darner color of it base color and will display the line as a broken line instead
                of a solid one. This value also determines the number of pips that price has to
                move back accross the line to reset it as an unbroken trend line again. This gives
                the program ability to determine when a possible false break has occoured. Like
                above this will self adjusted for 4/5 digit brokers. Any input here above or below
                the required range will default to the extream of the range, That is if you put
                the value of 15, the program will substitute it with 10.

            DefaultPrice, Default value is; 25. A value of 10 to 50 is required.
                This is the default Price level that new lines are drawn within the price window.
                That is this is the number of pips (whole pips) substracted from the high price
                were the new lines will appear in the chart window as determined from the top of
                the box. Again input here above or below the required range will default to the
                direction of the extream of the range, That is if you put the value of 75, the
                program will substitute it with the maximum value of 50.


            The chart needs to by shifted, using the 'Chart Shift' buttom on MT tool bar. This
            will give some visiable space to the right side of the chart and make the front of
            of the box area visable. One will also need to drag the 'Vertical Scale' to compress
            the chart window a little, to make the top and bottom of the box visiable. You must
            drag any trend line you draw pass the limits of this box to make them seen and managed
            by the program.




    TREND LINES:
        The drawning of trend lines is very simple, all one has to do is mouse over one of the 
        crayons and a short line will appear in the chart window in the color of the crayon the
        user has selected. The line as it first appears in the chart will have an active end and
        a static end to it. The right end is the end that is refered to as the active end and the
        left end is the static end.

        You can place the static end on any price bar you want the trend line to be anchored to.
        Including a price bar outside of the box. The active end then needs to be dragged till it
        is pulled out side of the box and released, so long as both the static and active ends are
        not both outside the SAME side of the box, in which case the line will be deleted.

        When the line is released the program will return the active end back to the limits of the
        box and turn off the lines hi-lighting, this will let the user know that the program has
        control of this line. From that point on the program will extend or contrat the line as
        required by prices movment. No additional attention is required by the user.

        As stated above you can not flip the line arround. If the active end of the trendline
        is behine the static end. That is, it has a bar time smaller then the static end the
        program will turn the line arround to place the line in its correct direction. You can
        not draw a line as a true vertical line neither.

        When price approches the trend line it will start to flash in color (blink) the distance
        to the trendline is set to 2 pips by default. it will continue to blink untill it surpasses
        the trend line by a set number of pips, 2 by default. At which point the line will stop
        flashing and turn to a darker color of its base color and appear as a broken line instead
        of a solid one. If sound alerts are set on the program will inform the user of the break
        included in the alert is the type of trend line and the direction of the break. It will
        only sound once when the line is first broken, it will not repeat the alert on each tick.

        The trend line will remain in that state unless price returns to test it. Again the code
        will warn the user that price is approching the trend line by flashing it. In this case it
        will be flashing it as a broken line not a solid one. If price penitrates the line again
        by the set number of pips, back through, it will return the line back to a solid one in
        its base color. This will reset the trendline and the sound alert to have the ability to
        be triggered again if price goes through it again at a later time.

        The program will extend and manage all trendlines that it sees including all broken trend
        lines. All will be kept extended to the box limits at all times. Exceptions to this are
        trend lines the user has applied to price that s/he has not draged the active end out
        side of the price box. These are not seen nor will they be managed by the program.

        Now the price box need not be visible if the user has set it to hiden, but it still exist
        to the program. The user still has to drag the active end of the trend line pass the
        box limits to have it managed by the program. One will know if the program has seen the
        line as it will be de-hi-lighted and contrated to the non visiable box.

        Any trend line can be deleted at will, with no effect on the opperation of the program
        or any other trend lines that may coexist on the chart. It can also be reasigned by the
        user, s/he only has to hi-light it again and drag the active end back into the box and
        redeploy it where one wants it and re-drag the active end pass the limits of the box
        again. The program will re-assign it resetting it back to its original state if the line
        was broken prier. The sound wave will be reset to play again when the line is broken.

        If your assignment or any re-assignment would make the trend line broken then the line
        will be applied as a broken line, as a result.




    SUPPORT AND RESISTANCE LINES:
        Support and resistance line are horizontal lines that must be level that is the
        start price and end price must be equal. The best way to assign a trend line as a
        S/R line is to grab it by the center hi-light and place it so that the left (static
        end) is were you want the line to be. Then drag the right end (active end) straght
        out the front of the box. Before letting it go, level it by sight and hold it till
        a small arrow appears at the left end of the line this will tell you that the line
        is recognized as a S/R line. After releasing the line the program will de-hi-light
        it and place the active end at the box's boarder.

        If the line is visially level is generally all it takes to have it recognized. As a
        S/R line. The arrow on the left of the line will appear as a hollow arrow (un-colored)
        and both Support and resistance will appear to have the same arrow. The program
        determines the line as a support or resistance by which side of price the line was
        originally placed.

        If the user wishes to remove a line all that is needed is to delete the LINE, and the
        program will remove the arrow when it finds the line missing. A S/R line can be reused
        by re-assigned it by hi-lighing and picking it up by the center and redeploying it as 
        directed above. The re-assignment can also be invert. A line that was formerly a
        support can be a new resistance line and vise verser. This all depend on which side
        of price you re-deploy the line.

        Here to, as in the trend lines, when price approches the line it will start to flash.
        When price breaks through the line it will be colored to a darken color of its base color
        and be broken and shorten. The arrow will disappear and the line will be abanden by the
        program. When abanden, a S/R line when broken can not be reset nor managed any further
        by the program. Even if price returns to it. It will remain on the price chart as a 
        referance to the user of a pass S/R line only. The user can how ever re-assign it as
        directed above, in the trend line section, if s/he so wishes and the Program will
        again manage that line.

        If the user wishes to move a SR line from one side of the bid line to the other s/he
        only needs to Hi-lite it and pull the line back into the box and replace it were 
        s/he wants it, and drag the active end back out side the box. If the active end is
        not pulled back into the box one may get an alert triggerd.

        The price differences of a S/R line to start warning and/or to actually break are the
        same as regular trend lines. The sound wave that is played will be determened by what
        type line it was when it was originally applied to the chart and the direction of price
        movment.




    MARRING SUPPORT WITH RESISTANCE:
        All the statments that apply for regular S/R lines also apply here too. along with some
        additional rules and conditions.

        To Pair off ( Marry ) two S/R lines these rules must be followed;
            1 Both lines have to be the same color.

            2 They have to be on different sides of the bid price when placed.

            3 They must be placed on the chart consecutively.

            It makes no differences which one is placed first, that is, above or below the
            bid price. so long as both are placed one after the other. This will give them
            consecutive numbering. The arrows although they may look the same are actually
            different. The lines above the bid price have all the same arrows and are of
            type 1. The lines that are under the bid price have all the same arrow but of
            type 2. This gives the program the ability to distingush which side of the bid
            price the lines are place, by the type arrow that is displayed at the left end
            of that line. They look the same but are actually different. 

            The program will let the user know that two lines are married by coloring in the
            arrows with the same color as the line color. Any arrow that is not colored 
            (hollow) are single lines.


        There are a few things that are not permitted in marring S/R lines;
            1 Marrages between two different colored lines is forbiden.

            2 Bigamy is not permitted. Only one line can be married to another.

            3 Same arrow marriages are not allowed. They must be from opperset
                sides of the bid line, with different arrow types.

            4 One should not braket one set of married lines with another set of
                married lines of the same color. In so doing you run the risk of
                of them, 'line swaping' between the two married couples.

            NOTE; All of the above, although true here, are give in a joking manner, with no
                  disrespect intended to anyone.

        Married S/R lines react to the same conditions as regular S/R lines except when one is 
        broken both get broken ( their arrows will be removed. the lines will be darken, the
        line will be broken, and they will be shorten ) and abandon by the program.

        The reason to have married S/R lines is to be able to apply them to both sides of a
        price range and be alerted to a break out of that range. As the sound waves will
        state which direction that price has broken out of the range.

        If you donot want to have the SR lines married, but would still like to straddle the
        the bid, Then you have to delete one line in between the two lines used to straddle a
        price range. In this case both lines will operate indipendently of each other.

        Other considerations with married pairs are;
            1 If the user moves one of the lines of a married pair to the same side as the
                other line it will desolve the marriage, and the arrows will turn hollow. A
                divorced pair can re-marry if the user drags one of the lines of a former
                married pair so that each are on different sides of the bid again.

            2 If the user deletes one of the lines of a married pair the arrow of that line
                will be removed by the program and the arrow of the remaining married line
                will be turn hollow. Indicating it is no longer married.

            3 The user is advised not to wait for a ciggar that states thats its a Type 1 or
                type 2 arrow, as offsprings are not programed into this version of the code.




    USING THE INCLUDE FILE:
        This indicator can be added to any other code block with the addition of 4 lines of
        code to the existing code (called subject code). These lines have to be in the correct
        places in the subject coding. The four lines are very easy to figure out were to place
        them by their names. No parameters are needed so this operation should be very easy for
        even someone with limited programing knowledge.

        The Crayon Trade lines will operated exactly alike either way you apply it. You will
        find no differents in it operation. The only precaution one needs to address is if
        the subject code uses any of the variable naming used in the Crayon Trend Line code
        you may run into some interesting results if that happens. To check for naming conflicts
        all of the Trend Line variables are decleared in one place at the outset in the code
        and a quick check there is suggested.

        The four lines of code and were to locate them in the subject code, are as follows;


                #include <Indicator Crayon Trend lines v100 b01.mqh>

            This line will introduce all of the needed code into the subjects code. It must be
            placed at the start of the subject code in the global area. The best place would
            be right after the #property tags. of the subject code.


                InitializeCrayonTrendLines();

            This line must appear in the subject's 'init()' function in the main flow of the
            program. That is, not inside any loops or re-directional coding.


                RunCrayonTrendLines();

            This line has to be pressent in the subjects 'start()' function. Here it would be
            best to have it as one of the first actionable line of code in the start() function
            as the crayon trend lines have exiting routines on conditions to check the dll files
            check box. This code will not function if dlls are not allowed or if your offline,
            or when your broker is closed like on the week ends. Therefor dont expect it to run
            when its attached to another code file either. If no connection is found it will
            print 'De-Activated' on the top of the screen were the crayons should be. Even if
            the Crayon Trend Lines not run in those conditions it will not prevent the subject
            code from running in any fastion, EXCEPT if the allow dlls is not checked ON. The
            trend line code will exit the subjects code, as well, till the user check the allow
            dlls.


                DeInitializeCrayonTrendLines();

            This line needs to go in the 'deint()' function in the main flow of the program.
            Not inside any loops or re directional code blocks.



        Very easy to add to an exsiting program, whats the benifits of it? The Crayon Trend Line
        code contains two things that would be of benifit to one who programs. One, the trendlines
        are colored, to used them inside an EA for trading and or position manageing. There is an
        array that tracks the line numbering etc... All in all if one want to use his imagination
        one could create other uses with out recreating this code.

        One last comment; If your running a tick generator within the MT window that the Crayon
        Trend Lines are running in you will really see it shine. The blinking of the trend lines
        when the code warns of a pending break is niffty and fast. Mouseing over the crayons is
        in real time, the trend line appears on the chart in a flash. The over all speed of 
        operation will amaize you.





  FILES DISCRIPTIONS: 




        The following files are needed and must be located in the correct directries for
        this program to run.

            The main programs files are to be installed in to the 'MT >> expert >> indicator'
            directory. These are the main files to operate the program. They are needed if
            one wants to run the program as a stand alone program, but are not needed if
            you are to use the include method and add the indicator to an exsiting program.
            The .ex4 file was supplied for those that are not able to compile .mq4 code.

                'Crayon Trend Lines v100 b01.mq4'  and/or
                'Crayon Trend Lines v100 b01.ex4'




            This include file is not needed if your running this indicator with the use of the
            main program file. The include file gives one the ability to add this code into an
            existing, coded indicator, EA, or script file. It make no differeance the type file
            one adds this include file to nor which window the existing code is assigned too,
            it will opperate just like the main program file. This file must be located in the
            'MT >> expert >> include' directory, if useing the include method of installation.

                'Indicator Crayon Trend lines v 100 b01.mqh'




            A dynamic link library (dll) must be located in the 'MT >> expert >> library'
            directory. This file reads your mouse pointer and reports back to MT of its
            location. This file is needed for both the main program code and it must be
            available to he include file as well. This dll file was created by: "Berkers
            Trading". They can be reached at: "http://quotar.com".

                'Mouse.dll'




            All of the following sound wave files must be located in the 'MT >> sound'
            directory. These are the sound waves call by the program on given events.
            All of these files are required for the use of the main program file and
            for the include format if used.

                Up Trend Broken.wav         SoundWave informs user of an up trend break.
                Down Trend Broken.wav       SoundWave informs user of a down trend break.
                Resistance Broken.wav       SoundWave informs user of a ressitance line break.
                Support Broken.wav          SoundWave informs user of a support line break.
                Range BO up side.wav        SoundWave informs user of a up side range break out.
                Range BO down side.wav      SoundWave informs user of a down side range break out.
                DLL Libraries Required.wav  SoundWave to informs user to turn on dll files.
                Welcome to trend lines.wav  SoundWave to welcome user to this program.





  TESTING AND DEBUGING: 




    The following information is given for those that want to add trade functions to this code
    with this information one can access the programs information. You should also read all the
    notes of the different procedures as well, this will give you a better understanding of how
    this program runs and precautions to stay away from. Under standing of this information is
    not needed for the general operations of the program.



    The line naming is as follows;

        5.51 732 CTL 0 Line Creator Trend 4 2
        5.51 732 CTL 0 Line Creator Arrow 4 2    2


            5.51            --- This is the graphic page layering that all graphics of this
                                program are drawn to.

            732             --- This is the program ID number, it will be different for
                                each run of the program, but will be the same for the
                                complete run, if you restart the program it will be derrerent
                                It will always be 3 digits in length. Vering from 101 to 999.

            CTL             --- This is the program symbol, it will always be the same in all
                                runs of the program. CTL stands for Crayon Trend Lines.

            0               --- This is the window ID and it will always be 0 as all graphics
                                are displayed on the main chart window.

            Line Creator    --- Ths is the group name and it will be the same in all the
                                graphic in this code.

            Trend           --- This is the sub group name and it identifies the part of the
                                graphics drawn by this program. It will not be the same for
                                all graphics but for all trendlines and RS lines it will be
                                'Trend' if the line is a RS line you will have a matching
                                'Arrow' sub group that will match the line nameing.

            4               --- This is the Type of line; that is, the color of the line. The
                                numbering of the colors is as;
                                    red    =  1
                                    green  =  2
                                    blue   =  3
                                    gold   =  4

            2               --- This is the actual line count number it can be 1 to 9,999 and
                                is used to identify each line that the program draws. This
                                number can repeat for each type (color) of line. That is 
                                you have 1 in each colored line. this number is not adjusted
                                for lines one deletes it is a running count of the line.




        on arrow graphics we have one more element;

           2                --- The last number is either going to be a 1 or a 2 which denotes
                                which side of the bid line the SR line was originally placed.
                                    above the bid  =  1 a resistance line.
                                    below the bid  =  2 a support line.

                                It will have 4 spaces before the number this is to leave room
                                for the line numbering. if these spaces are not present the 
                                program will be limited in recognizing 10 line numbers so this
                                must be accouted for when seraching for arrow objects.




---------------------------------------------------------------------------------------------------
    There are 3 arrays that hold line information during program runs;

        int   // Counting array;     The zero zero element is not used;
            TrendLines[ 0 ][ 1 ]; // Holds actual count of Red trendlines that are on the chart.
            TrendLines[ 0 ][ 2 ]; // Holds actual count of Green trendlines that are on the chart.
            TrendLines[ 0 ][ 3 ]; // Holds actual count of Blue trendlines that are on the chart.
            TrendLines[ 0 ][ 4 ]; // Holds actual count of Gold trendlines that are on the chart.

            TrendLines[ 1 ][ 1 ]; // Holds the total count of all Red trendlines drawn.
            TrendLines[ 1 ][ 2 ]; // Holds the total count of all Green trendlines drawn.
            TrendLines[ 1 ][ 3 ]; // Holds the total count of all Blue trendlines drawn.
            TrendLines[ 1 ][ 4 ]; // Holds the total count of all Gold trendlines drawn.




---------------------------------------------------------------------------------------------------
        string   // Last triggered array;    all zero elements are not used in all dimementions;
            The 1 element contains the name of the last up trend line to trigger a sound wave.
            LastSound[ 1 ][ 1 ]; // Holds the name of the last Red line.
            LastSound[ 1 ][ 2 ]; // Holds the name of the last Green line.
            LastSound[ 1 ][ 3 ]; // Holds the name of the last Blue line.
            LastSound[ 1 ][ 4 ]; // Holds the name of the last Gold line.

            The 2 element contains the name of the last down trend line to trigger a sound wave.
            LastSound[ 2 ][ 1 ]; // Holds the name of the last Red line.
            LastSound[ 2 ][ 2 ]; // Holds the name of the last Green line.
            LastSound[ 2 ][ 3 ]; // Holds the name of the last Blue line.
            LastSound[ 2 ][ 4 ]; // Holds the name of the last Gold line.

            The 3 element contains the name of the last resistance line to trigger a sound wave.
            LastSound[ 3 ][ 1 ]; // Holds the name of the last Red line.
            LastSound[ 3 ][ 2 ]; // Holds the name of the last Green line.
            LastSound[ 3 ][ 3 ]; // Holds the name of the last Blue line.
            LastSound[ 3 ][ 4 ]; // Holds the name of the last Gold line.

            The 4 element contains the name of the last support line to trigger a sound wave.
            LastSound[ 4 ][ 1 ]; // Holds the name of the last Red line.
            LastSound[ 4 ][ 2 ]; // Holds the name of the last Green line.
            LastSound[ 4 ][ 3 ]; // Holds the name of the last Blue line.
            LastSound[ 4 ][ 4 ]; // Holds the name of the last Gold line.

            The 5 element contains the name of the last upward range BO to trigger a sound wave.
            LastSound[ 5 ][ 1 ]; // Holds the name of the last Red line.
            LastSound[ 5 ][ 2 ]; // Holds the name of the last Green line.
            LastSound[ 5 ][ 3 ]; // Holds the name of the last Blue line.
            LastSound[ 5 ][ 4 ]; // Holds the name of the last Gold line.

            The 6 element contains the name of the last downward range BO to trigger a wave.
            LastSound[ 6 ][ 1 ]; // Holds the name of the last Red line.
            LastSound[ 6 ][ 2 ]; // Holds the name of the last Green line.
            LastSound[ 6 ][ 3 ]; // Holds the name of the last Blue line.
            LastSound[ 6 ][ 4 ]; // Holds the name of the last Gold line.

            if one of the sound waves have not been triggered by the given line color
            then that element will be empty. This array is filled even if the usre
            has turned off the playing of the sound waves.




---------------------------------------------------------------------------------------------------
        color   // Line color array;    all zero elements are not used in both dimementions;
                TrendColors[ 1 ][ 1 ]  =  @_MinorColor;             Red
                TrendColors[ 1 ][ 2 ]  =  @_SecondaryColor;         Green
                TrendColors[ 1 ][ 3 ]  =  @_PrimaryColor;           Blue
                TrendColors[ 1 ][ 4 ]  =  @_ExtendedColor;          Gold

                TrendColors[ 2 ][ 1 ]  =  @_BrokeMinorColor;        Dark Red
                TrendColors[ 2 ][ 2 ]  =  @_BrokeSecondaryColor;    Dark Green
                TrendColors[ 2 ][ 3 ]  =  @_BrokePrimaryColor;      Dark Blue
                TrendColors[ 2 ][ 4 ]  =  @_BrokeExtendedColor;     Dark Gold

        All color assignments can be changed in the 'Defined Constant' section of the code.




        Be very carful in changing any code in the program itself as one change may have
        some unwanted affect.





  VERSION UPDATES: 




        Current Revisions:
            Version 1.00 b01 pb     03.11.2012
                    First Beta release.


            Version 1.00 b02 pb     03.19.2012
                    Currected bug in DirvorceCourt Procedure.




        Future Enhancement:
            -





  SCRIPT NOTES: 




    NOTE 1:

    There are no external variables in this code. If one wishes to expose the Default attribute
    section as externals one only needs to add the key word  'extern'  in front of the variable
    declarations statements in that section and all the variables will be exposed. That is;

        extern
            bool
                ShowBox        =   True, // Box Drawing Switch, turns on and off the price box.
                ShowSRmarks    =   True, // This turns on and off the RS arrows.
                UnderPrice     =  False, // Switch to place lines on top of or below price bars.
                SoundAlert     =   True, // Switch to turn on and off PlaySound() function.
                @_Refresh      =   True; // Switch to Refresh Graphic Display.

        extern
            int
                ...
                ...
                ...

        extern
            double
                ...
                ...
                ...




    NOTE 2:

    The four spaces between the line count and the arrow on the arrow objects are needed do not
    remove or change them or the program will not find the arrows. This large space was left to
    give the program the ability to have up to 9,999 trend line of each color recogonized. This
    should be more then needed for all users. With out the spaces the program will be able to
    see only 10 lines.




    NOTE 3:

    Trader Keit is not only a mad man but has been comfirmed by his doctor to be sick and
    unstable requireing additude debugging. Not to mention that he is genernally considered
    by most to be socially dysfunctional.

    I hope this program puts a smile on your face each day you trade and helps in your trading
    success.

        Keit





  CODE STORAGE: 




    Types of notes;
        TC!{...}: Test Code Notes
        DB!{...}: Debugging Notes
        RD!{...}: Reserch Development Notes
        CN!{...}: Code Notes
        CS!{...}: Code Stub Notes




/*===============================================================================================|\
||                                                                                               ||
||  Public Private Function Routine GUI Procedure Property    v1.00    Date 00.00.2012     KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     None.                                                                           ||
||                                                                                               ||
||  Parameters:  None.                                                                           ||
||                                                                                               ||
||  Note:        None.                                                                           ||
||                                                                                               ||
||  Example:     None.                                                                           ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/




//*/
#define                                 END~PROGRAM~SCRIPT~[mq4]                                 00
// [ v1.rev.01-01-2012] 




